<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLeadSource ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLeadSource
 * @subpackage Arrays
 */
class ArrayOfLeadSource extends AbstractStructArrayBase
{
    /**
     * The LeadSource
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LeadSource[]
     */
    public $LeadSource;
    /**
     * Constructor method for ArrayOfLeadSource
     * @uses ArrayOfLeadSource::setLeadSource()
     * @param \StructType\LeadSource[] $leadSource
     */
    public function __construct(array $leadSource = array())
    {
        $this
            ->setLeadSource($leadSource);
    }
    /**
     * Get LeadSource value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LeadSource[]|null
     */
    public function getLeadSource()
    {
        return isset($this->LeadSource) ? $this->LeadSource : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLeadSource method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLeadSource method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLeadSourceForArrayConstraintsFromSetLeadSource(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLeadSourceLeadSourceItem) {
            // validation for constraint: itemType
            if (!$arrayOfLeadSourceLeadSourceItem instanceof \StructType\LeadSource) {
                $invalidValues[] = is_object($arrayOfLeadSourceLeadSourceItem) ? get_class($arrayOfLeadSourceLeadSourceItem) : sprintf('%s(%s)', gettype($arrayOfLeadSourceLeadSourceItem), var_export($arrayOfLeadSourceLeadSourceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LeadSource property can only contain items of type \StructType\LeadSource, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LeadSource value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LeadSource[] $leadSource
     * @return \ArrayType\ArrayOfLeadSource
     */
    public function setLeadSource(array $leadSource = array())
    {
        // validation for constraint: array
        if ('' !== ($leadSourceArrayErrorMessage = self::validateLeadSourceForArrayConstraintsFromSetLeadSource($leadSource))) {
            throw new \InvalidArgumentException($leadSourceArrayErrorMessage, __LINE__);
        }
        if (is_null($leadSource) || (is_array($leadSource) && empty($leadSource))) {
            unset($this->LeadSource);
        } else {
            $this->LeadSource = $leadSource;
        }
        return $this;
    }
    /**
     * Add item to LeadSource value
     * @throws \InvalidArgumentException
     * @param \StructType\LeadSource $item
     * @return \ArrayType\ArrayOfLeadSource
     */
    public function addToLeadSource(\StructType\LeadSource $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LeadSource) {
            throw new \InvalidArgumentException(sprintf('The LeadSource property can only contain items of type \StructType\LeadSource, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LeadSource[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LeadSource|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LeadSource|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LeadSource|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LeadSource|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LeadSource|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LeadSource
     */
    public function getAttributeName()
    {
        return 'LeadSource';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLeadSource
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
