<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleTrim ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVehicleTrim
 * @subpackage Arrays
 */
class ArrayOfVehicleTrim extends AbstractStructArrayBase
{
    /**
     * The VehicleTrim
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleTrim[]
     */
    public $VehicleTrim;
    /**
     * Constructor method for ArrayOfVehicleTrim
     * @uses ArrayOfVehicleTrim::setVehicleTrim()
     * @param \StructType\VehicleTrim[] $vehicleTrim
     */
    public function __construct(array $vehicleTrim = array())
    {
        $this
            ->setVehicleTrim($vehicleTrim);
    }
    /**
     * Get VehicleTrim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleTrim[]|null
     */
    public function getVehicleTrim()
    {
        return isset($this->VehicleTrim) ? $this->VehicleTrim : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleTrim method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleTrim method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleTrimForArrayConstraintsFromSetVehicleTrim(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleTrimVehicleTrimItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleTrimVehicleTrimItem instanceof \StructType\VehicleTrim) {
                $invalidValues[] = is_object($arrayOfVehicleTrimVehicleTrimItem) ? get_class($arrayOfVehicleTrimVehicleTrimItem) : sprintf('%s(%s)', gettype($arrayOfVehicleTrimVehicleTrimItem), var_export($arrayOfVehicleTrimVehicleTrimItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleTrim property can only contain items of type \StructType\VehicleTrim, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleTrim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleTrim[] $vehicleTrim
     * @return \ArrayType\ArrayOfVehicleTrim
     */
    public function setVehicleTrim(array $vehicleTrim = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleTrimArrayErrorMessage = self::validateVehicleTrimForArrayConstraintsFromSetVehicleTrim($vehicleTrim))) {
            throw new \InvalidArgumentException($vehicleTrimArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleTrim) || (is_array($vehicleTrim) && empty($vehicleTrim))) {
            unset($this->VehicleTrim);
        } else {
            $this->VehicleTrim = $vehicleTrim;
        }
        return $this;
    }
    /**
     * Add item to VehicleTrim value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleTrim $item
     * @return \ArrayType\ArrayOfVehicleTrim
     */
    public function addToVehicleTrim(\StructType\VehicleTrim $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleTrim) {
            throw new \InvalidArgumentException(sprintf('The VehicleTrim property can only contain items of type \StructType\VehicleTrim, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleTrim[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleTrim|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleTrim|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleTrim|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleTrim|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleTrim|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleTrim
     */
    public function getAttributeName()
    {
        return 'VehicleTrim';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVehicleTrim
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
