<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfsecureWebService.EntityNote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfsecureWebService.EntityNote
 * @subpackage Arrays
 */
class ArrayOfsecureWebService_EntityNote extends AbstractStructArrayBase
{
    /**
     * The secureWebService_EntityNote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_EntityNote[]
     */
    public $secureWebService_EntityNote;
    /**
     * Constructor method for ArrayOfsecureWebService.EntityNote
     * @uses ArrayOfsecureWebService_EntityNote::setSecureWebService_EntityNote()
     * @param \StructType\SecureWebService_EntityNote[] $secureWebService_EntityNote
     */
    public function __construct(array $secureWebService_EntityNote = array())
    {
        $this
            ->setSecureWebService_EntityNote($secureWebService_EntityNote);
    }
    /**
     * Get secureWebService_EntityNote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_EntityNote[]|null
     */
    public function getSecureWebService_EntityNote()
    {
        return isset($this->{'secureWebService.EntityNote'}) ? $this->{'secureWebService.EntityNote'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSecureWebService_EntityNote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSecureWebService_EntityNote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSecureWebService_EntityNoteForArrayConstraintsFromSetSecureWebService_EntityNote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfsecureWebService_EntityNoteSecureWebService_EntityNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfsecureWebService_EntityNoteSecureWebService_EntityNoteItem instanceof \StructType\SecureWebService_EntityNote) {
                $invalidValues[] = is_object($arrayOfsecureWebService_EntityNoteSecureWebService_EntityNoteItem) ? get_class($arrayOfsecureWebService_EntityNoteSecureWebService_EntityNoteItem) : sprintf('%s(%s)', gettype($arrayOfsecureWebService_EntityNoteSecureWebService_EntityNoteItem), var_export($arrayOfsecureWebService_EntityNoteSecureWebService_EntityNoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The secureWebService_EntityNote property can only contain items of type \StructType\SecureWebService_EntityNote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set secureWebService_EntityNote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_EntityNote[] $secureWebService_EntityNote
     * @return \ArrayType\ArrayOfsecureWebService_EntityNote
     */
    public function setSecureWebService_EntityNote(array $secureWebService_EntityNote = array())
    {
        // validation for constraint: array
        if ('' !== ($secureWebService_EntityNoteArrayErrorMessage = self::validateSecureWebService_EntityNoteForArrayConstraintsFromSetSecureWebService_EntityNote($secureWebService_EntityNote))) {
            throw new \InvalidArgumentException($secureWebService_EntityNoteArrayErrorMessage, __LINE__);
        }
        if (is_null($secureWebService_EntityNote) || (is_array($secureWebService_EntityNote) && empty($secureWebService_EntityNote))) {
            unset($this->secureWebService_EntityNote, $this->{'secureWebService.EntityNote'});
        } else {
            $this->secureWebService_EntityNote = $this->{'secureWebService.EntityNote'} = $secureWebService_EntityNote;
        }
        return $this;
    }
    /**
     * Add item to secureWebService_EntityNote value
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_EntityNote $item
     * @return \ArrayType\ArrayOfsecureWebService_EntityNote
     */
    public function addToSecureWebService_EntityNote(\StructType\SecureWebService_EntityNote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SecureWebService_EntityNote) {
            throw new \InvalidArgumentException(sprintf('The secureWebService_EntityNote property can only contain items of type \StructType\SecureWebService_EntityNote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->secureWebService_EntityNote[] = $this->{'secureWebService.EntityNote'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SecureWebService_EntityNote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SecureWebService_EntityNote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SecureWebService_EntityNote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SecureWebService_EntityNote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SecureWebService_EntityNote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string secureWebService.EntityNote
     */
    public function getAttributeName()
    {
        return 'secureWebService.EntityNote';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfsecureWebService_EntityNote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
