<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfsecureWebService.GetUsersReturn ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfsecureWebService.GetUsersReturn
 * @subpackage Arrays
 */
class ArrayOfsecureWebService_GetUsersReturn extends AbstractStructArrayBase
{
    /**
     * The secureWebService_GetUsersReturn
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_GetUsersReturn[]
     */
    public $secureWebService_GetUsersReturn;
    /**
     * Constructor method for ArrayOfsecureWebService.GetUsersReturn
     * @uses ArrayOfsecureWebService_GetUsersReturn::setSecureWebService_GetUsersReturn()
     * @param \StructType\SecureWebService_GetUsersReturn[] $secureWebService_GetUsersReturn
     */
    public function __construct(array $secureWebService_GetUsersReturn = array())
    {
        $this
            ->setSecureWebService_GetUsersReturn($secureWebService_GetUsersReturn);
    }
    /**
     * Get secureWebService_GetUsersReturn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_GetUsersReturn[]|null
     */
    public function getSecureWebService_GetUsersReturn()
    {
        return isset($this->{'secureWebService.GetUsersReturn'}) ? $this->{'secureWebService.GetUsersReturn'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSecureWebService_GetUsersReturn method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSecureWebService_GetUsersReturn method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSecureWebService_GetUsersReturnForArrayConstraintsFromSetSecureWebService_GetUsersReturn(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfsecureWebService_GetUsersReturnSecureWebService_GetUsersReturnItem) {
            // validation for constraint: itemType
            if (!$arrayOfsecureWebService_GetUsersReturnSecureWebService_GetUsersReturnItem instanceof \StructType\SecureWebService_GetUsersReturn) {
                $invalidValues[] = is_object($arrayOfsecureWebService_GetUsersReturnSecureWebService_GetUsersReturnItem) ? get_class($arrayOfsecureWebService_GetUsersReturnSecureWebService_GetUsersReturnItem) : sprintf('%s(%s)', gettype($arrayOfsecureWebService_GetUsersReturnSecureWebService_GetUsersReturnItem), var_export($arrayOfsecureWebService_GetUsersReturnSecureWebService_GetUsersReturnItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The secureWebService_GetUsersReturn property can only contain items of type \StructType\SecureWebService_GetUsersReturn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set secureWebService_GetUsersReturn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_GetUsersReturn[] $secureWebService_GetUsersReturn
     * @return \ArrayType\ArrayOfsecureWebService_GetUsersReturn
     */
    public function setSecureWebService_GetUsersReturn(array $secureWebService_GetUsersReturn = array())
    {
        // validation for constraint: array
        if ('' !== ($secureWebService_GetUsersReturnArrayErrorMessage = self::validateSecureWebService_GetUsersReturnForArrayConstraintsFromSetSecureWebService_GetUsersReturn($secureWebService_GetUsersReturn))) {
            throw new \InvalidArgumentException($secureWebService_GetUsersReturnArrayErrorMessage, __LINE__);
        }
        if (is_null($secureWebService_GetUsersReturn) || (is_array($secureWebService_GetUsersReturn) && empty($secureWebService_GetUsersReturn))) {
            unset($this->secureWebService_GetUsersReturn, $this->{'secureWebService.GetUsersReturn'});
        } else {
            $this->secureWebService_GetUsersReturn = $this->{'secureWebService.GetUsersReturn'} = $secureWebService_GetUsersReturn;
        }
        return $this;
    }
    /**
     * Add item to secureWebService_GetUsersReturn value
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_GetUsersReturn $item
     * @return \ArrayType\ArrayOfsecureWebService_GetUsersReturn
     */
    public function addToSecureWebService_GetUsersReturn(\StructType\SecureWebService_GetUsersReturn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SecureWebService_GetUsersReturn) {
            throw new \InvalidArgumentException(sprintf('The secureWebService_GetUsersReturn property can only contain items of type \StructType\SecureWebService_GetUsersReturn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->secureWebService_GetUsersReturn[] = $this->{'secureWebService.GetUsersReturn'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SecureWebService_GetUsersReturn|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SecureWebService_GetUsersReturn|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SecureWebService_GetUsersReturn|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SecureWebService_GetUsersReturn|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SecureWebService_GetUsersReturn|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string secureWebService.GetUsersReturn
     */
    public function getAttributeName()
    {
        return 'secureWebService.GetUsersReturn';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfsecureWebService_GetUsersReturn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
