<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfsecureWebService.ImportQuoteOption ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfsecureWebService.ImportQuoteOption
 * @subpackage Arrays
 */
class ArrayOfsecureWebService_ImportQuoteOption extends AbstractStructArrayBase
{
    /**
     * The secureWebService_ImportQuoteOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_ImportQuoteOption[]
     */
    public $secureWebService_ImportQuoteOption;
    /**
     * Constructor method for ArrayOfsecureWebService.ImportQuoteOption
     * @uses ArrayOfsecureWebService_ImportQuoteOption::setSecureWebService_ImportQuoteOption()
     * @param \StructType\SecureWebService_ImportQuoteOption[] $secureWebService_ImportQuoteOption
     */
    public function __construct(array $secureWebService_ImportQuoteOption = array())
    {
        $this
            ->setSecureWebService_ImportQuoteOption($secureWebService_ImportQuoteOption);
    }
    /**
     * Get secureWebService_ImportQuoteOption value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_ImportQuoteOption[]|null
     */
    public function getSecureWebService_ImportQuoteOption()
    {
        return isset($this->{'secureWebService.ImportQuoteOption'}) ? $this->{'secureWebService.ImportQuoteOption'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSecureWebService_ImportQuoteOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSecureWebService_ImportQuoteOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSecureWebService_ImportQuoteOptionForArrayConstraintsFromSetSecureWebService_ImportQuoteOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfsecureWebService_ImportQuoteOptionSecureWebService_ImportQuoteOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfsecureWebService_ImportQuoteOptionSecureWebService_ImportQuoteOptionItem instanceof \StructType\SecureWebService_ImportQuoteOption) {
                $invalidValues[] = is_object($arrayOfsecureWebService_ImportQuoteOptionSecureWebService_ImportQuoteOptionItem) ? get_class($arrayOfsecureWebService_ImportQuoteOptionSecureWebService_ImportQuoteOptionItem) : sprintf('%s(%s)', gettype($arrayOfsecureWebService_ImportQuoteOptionSecureWebService_ImportQuoteOptionItem), var_export($arrayOfsecureWebService_ImportQuoteOptionSecureWebService_ImportQuoteOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The secureWebService_ImportQuoteOption property can only contain items of type \StructType\SecureWebService_ImportQuoteOption, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set secureWebService_ImportQuoteOption value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_ImportQuoteOption[] $secureWebService_ImportQuoteOption
     * @return \ArrayType\ArrayOfsecureWebService_ImportQuoteOption
     */
    public function setSecureWebService_ImportQuoteOption(array $secureWebService_ImportQuoteOption = array())
    {
        // validation for constraint: array
        if ('' !== ($secureWebService_ImportQuoteOptionArrayErrorMessage = self::validateSecureWebService_ImportQuoteOptionForArrayConstraintsFromSetSecureWebService_ImportQuoteOption($secureWebService_ImportQuoteOption))) {
            throw new \InvalidArgumentException($secureWebService_ImportQuoteOptionArrayErrorMessage, __LINE__);
        }
        if (is_null($secureWebService_ImportQuoteOption) || (is_array($secureWebService_ImportQuoteOption) && empty($secureWebService_ImportQuoteOption))) {
            unset($this->secureWebService_ImportQuoteOption, $this->{'secureWebService.ImportQuoteOption'});
        } else {
            $this->secureWebService_ImportQuoteOption = $this->{'secureWebService.ImportQuoteOption'} = $secureWebService_ImportQuoteOption;
        }
        return $this;
    }
    /**
     * Add item to secureWebService_ImportQuoteOption value
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_ImportQuoteOption $item
     * @return \ArrayType\ArrayOfsecureWebService_ImportQuoteOption
     */
    public function addToSecureWebService_ImportQuoteOption(\StructType\SecureWebService_ImportQuoteOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SecureWebService_ImportQuoteOption) {
            throw new \InvalidArgumentException(sprintf('The secureWebService_ImportQuoteOption property can only contain items of type \StructType\SecureWebService_ImportQuoteOption, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->secureWebService_ImportQuoteOption[] = $this->{'secureWebService.ImportQuoteOption'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SecureWebService_ImportQuoteOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SecureWebService_ImportQuoteOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SecureWebService_ImportQuoteOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SecureWebService_ImportQuoteOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SecureWebService_ImportQuoteOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string secureWebService.ImportQuoteOption
     */
    public function getAttributeName()
    {
        return 'secureWebService.ImportQuoteOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfsecureWebService_ImportQuoteOption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
