<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfsecureWebService.ImportQuotePayment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfsecureWebService.ImportQuotePayment
 * @subpackage Arrays
 */
class ArrayOfsecureWebService_ImportQuotePayment extends AbstractStructArrayBase
{
    /**
     * The secureWebService_ImportQuotePayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_ImportQuotePayment[]
     */
    public $secureWebService_ImportQuotePayment;
    /**
     * Constructor method for ArrayOfsecureWebService.ImportQuotePayment
     * @uses ArrayOfsecureWebService_ImportQuotePayment::setSecureWebService_ImportQuotePayment()
     * @param \StructType\SecureWebService_ImportQuotePayment[] $secureWebService_ImportQuotePayment
     */
    public function __construct(array $secureWebService_ImportQuotePayment = array())
    {
        $this
            ->setSecureWebService_ImportQuotePayment($secureWebService_ImportQuotePayment);
    }
    /**
     * Get secureWebService_ImportQuotePayment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_ImportQuotePayment[]|null
     */
    public function getSecureWebService_ImportQuotePayment()
    {
        return isset($this->{'secureWebService.ImportQuotePayment'}) ? $this->{'secureWebService.ImportQuotePayment'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSecureWebService_ImportQuotePayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSecureWebService_ImportQuotePayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSecureWebService_ImportQuotePaymentForArrayConstraintsFromSetSecureWebService_ImportQuotePayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfsecureWebService_ImportQuotePaymentSecureWebService_ImportQuotePaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfsecureWebService_ImportQuotePaymentSecureWebService_ImportQuotePaymentItem instanceof \StructType\SecureWebService_ImportQuotePayment) {
                $invalidValues[] = is_object($arrayOfsecureWebService_ImportQuotePaymentSecureWebService_ImportQuotePaymentItem) ? get_class($arrayOfsecureWebService_ImportQuotePaymentSecureWebService_ImportQuotePaymentItem) : sprintf('%s(%s)', gettype($arrayOfsecureWebService_ImportQuotePaymentSecureWebService_ImportQuotePaymentItem), var_export($arrayOfsecureWebService_ImportQuotePaymentSecureWebService_ImportQuotePaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The secureWebService_ImportQuotePayment property can only contain items of type \StructType\SecureWebService_ImportQuotePayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set secureWebService_ImportQuotePayment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_ImportQuotePayment[] $secureWebService_ImportQuotePayment
     * @return \ArrayType\ArrayOfsecureWebService_ImportQuotePayment
     */
    public function setSecureWebService_ImportQuotePayment(array $secureWebService_ImportQuotePayment = array())
    {
        // validation for constraint: array
        if ('' !== ($secureWebService_ImportQuotePaymentArrayErrorMessage = self::validateSecureWebService_ImportQuotePaymentForArrayConstraintsFromSetSecureWebService_ImportQuotePayment($secureWebService_ImportQuotePayment))) {
            throw new \InvalidArgumentException($secureWebService_ImportQuotePaymentArrayErrorMessage, __LINE__);
        }
        if (is_null($secureWebService_ImportQuotePayment) || (is_array($secureWebService_ImportQuotePayment) && empty($secureWebService_ImportQuotePayment))) {
            unset($this->secureWebService_ImportQuotePayment, $this->{'secureWebService.ImportQuotePayment'});
        } else {
            $this->secureWebService_ImportQuotePayment = $this->{'secureWebService.ImportQuotePayment'} = $secureWebService_ImportQuotePayment;
        }
        return $this;
    }
    /**
     * Add item to secureWebService_ImportQuotePayment value
     * @throws \InvalidArgumentException
     * @param \StructType\SecureWebService_ImportQuotePayment $item
     * @return \ArrayType\ArrayOfsecureWebService_ImportQuotePayment
     */
    public function addToSecureWebService_ImportQuotePayment(\StructType\SecureWebService_ImportQuotePayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SecureWebService_ImportQuotePayment) {
            throw new \InvalidArgumentException(sprintf('The secureWebService_ImportQuotePayment property can only contain items of type \StructType\SecureWebService_ImportQuotePayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->secureWebService_ImportQuotePayment[] = $this->{'secureWebService.ImportQuotePayment'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SecureWebService_ImportQuotePayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SecureWebService_ImportQuotePayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SecureWebService_ImportQuotePayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SecureWebService_ImportQuotePayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SecureWebService_ImportQuotePayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string secureWebService.ImportQuotePayment
     */
    public function getAttributeName()
    {
        return 'secureWebService.ImportQuotePayment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfsecureWebService_ImportQuotePayment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
