<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfanyType' => '\\ArrayType\\ArrayOfanyType',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'LeadVehicle' => '\\StructType\\LeadVehicle',
            'ContactVehicle' => '\\StructType\\ContactVehicle',
            'AltVehicle' => '\\StructType\\AltVehicle',
            'VehicleMake' => '\\StructType\\VehicleMake',
            'ArrayOfVehicleModel' => '\\ArrayType\\ArrayOfVehicleModel',
            'VehicleModel' => '\\StructType\\VehicleModel',
            'ArrayOfVehicleMake' => '\\ArrayType\\ArrayOfVehicleMake',
            'VehicleTrim' => '\\StructType\\VehicleTrim',
            'ArrayOfVehicleTrim' => '\\ArrayType\\ArrayOfVehicleTrim',
            'ArrayOfPickList' => '\\ArrayType\\ArrayOfPickList',
            'PickList' => '\\StructType\\PickList',
            'Lead' => '\\StructType\\Lead',
            'Contact' => '\\StructType\\Contact',
            'ArrayOfBaseEntity' => '\\ArrayType\\ArrayOfBaseEntity',
            'BaseEntity' => '\\StructType\\BaseEntity',
            'LeadAddress' => '\\StructType\\LeadAddress',
            'Address' => '\\StructType\\Address',
            'CampaignTarget' => '\\StructType\\CampaignTarget',
            'TargetResponse' => '\\StructType\\TargetResponse',
            'ArrayOfGetWarrantyRates_Result' => '\\ArrayType\\ArrayOfGetWarrantyRates_Result',
            'GetWarrantyRates_Result' => '\\StructType\\GetWarrantyRates_Result',
            'Coverage' => '\\StructType\\Coverage',
            'Payment' => '\\StructType\\Payment',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'ArrayOfPolicy' => '\\ArrayType\\ArrayOfPolicy',
            'Policy' => '\\StructType\\Policy',
            'Quote' => '\\StructType\\Quote',
            'History' => '\\StructType\\History',
            'PhoneCall' => '\\StructType\\PhoneCall',
            'ArrayOfRecordQueueEntry' => '\\ArrayType\\ArrayOfRecordQueueEntry',
            'RecordQueueEntry' => '\\StructType\\RecordQueueEntry',
            'ArrayOfAccount' => '\\ArrayType\\ArrayOfAccount',
            'Account' => '\\StructType\\Account',
            'ArrayOfLeadSource' => '\\ArrayType\\ArrayOfLeadSource',
            'LeadSource' => '\\StructType\\LeadSource',
            'ArrayOfCampaign' => '\\ArrayType\\ArrayOfCampaign',
            'Campaign' => '\\StructType\\Campaign',
            'User' => '\\StructType\\User',
            'ArrayOfAttachment' => '\\ArrayType\\ArrayOfAttachment',
            'Attachment' => '\\StructType\\Attachment',
            'secureWebService.ImportLeadData' => '\\StructType\\SecureWebService_ImportLeadData',
            'secureWebService.ImportLeadReturn' => '\\StructType\\SecureWebService_ImportLeadReturn',
            'ArrayOfsecureWebService.PostalCodeValidation' => '\\ArrayType\\ArrayOfsecureWebService_PostalCodeValidation',
            'secureWebService.PostalCodeValidation' => '\\StructType\\SecureWebService_PostalCodeValidation',
            'secureWebService.RangeFilter' => '\\StructType\\SecureWebService_RangeFilter',
            'secureWebService.GetRatesDecodedParams' => '\\StructType\\SecureWebService_GetRatesDecodedParams',
            'secureWebService.ImportQuoteData' => '\\StructType\\SecureWebService_ImportQuoteData',
            'ArrayOfsecureWebService.ImportQuoteOption' => '\\ArrayType\\ArrayOfsecureWebService_ImportQuoteOption',
            'secureWebService.ImportQuoteOption' => '\\StructType\\SecureWebService_ImportQuoteOption',
            'ArrayOfsecureWebService.ImportQuotePayment' => '\\ArrayType\\ArrayOfsecureWebService_ImportQuotePayment',
            'secureWebService.ImportQuotePayment' => '\\StructType\\SecureWebService_ImportQuotePayment',
            'secureWebService.ImportQuotePaymentSource' => '\\StructType\\SecureWebService_ImportQuotePaymentSource',
            'ArrayOfsecureWebService.PoliciesByDateRange2' => '\\ArrayType\\ArrayOfsecureWebService_PoliciesByDateRange2',
            'secureWebService.PoliciesByDateRange2' => '\\StructType\\SecureWebService_PoliciesByDateRange2',
            'ArrayOfsecureWebService.PoliciesByDateRange3' => '\\ArrayType\\ArrayOfsecureWebService_PoliciesByDateRange3',
            'secureWebService.PoliciesByDateRange3' => '\\StructType\\SecureWebService_PoliciesByDateRange3',
            'ArrayOfsecureWebService.EntityNote' => '\\ArrayType\\ArrayOfsecureWebService_EntityNote',
            'secureWebService.EntityNote' => '\\StructType\\SecureWebService_EntityNote',
            'secureWebService.DecodeVinReturn' => '\\StructType\\SecureWebService_DecodeVinReturn',
            'ArrayOfsecureWebService.GetUsersReturn' => '\\ArrayType\\ArrayOfsecureWebService_GetUsersReturn',
            'secureWebService.GetUsersReturn' => '\\StructType\\SecureWebService_GetUsersReturn',
            'ArrayOfsecureWebService.QueryReportParameter' => '\\ArrayType\\ArrayOfsecureWebService_QueryReportParameter',
            'secureWebService.QueryReportParameter' => '\\StructType\\SecureWebService_QueryReportParameter',
            'ImportLead' => '\\StructType\\ImportLead',
            'ImportLeadResponse' => '\\StructType\\ImportLeadResponse',
            'GetVehicleModelsByMake' => '\\StructType\\GetVehicleModelsByMake',
            'GetVehicleModelsByMakeResponse' => '\\StructType\\GetVehicleModelsByMakeResponse',
            'GetVehicleMakes' => '\\StructType\\GetVehicleMakes',
            'GetVehicleMakesResponse' => '\\StructType\\GetVehicleMakesResponse',
            'GetVehicleTrimLevelsByModel' => '\\StructType\\GetVehicleTrimLevelsByModel',
            'GetVehicleTrimLevelsByModelResponse' => '\\StructType\\GetVehicleTrimLevelsByModelResponse',
            'GetPickListValues' => '\\StructType\\GetPickListValues',
            'GetPickListValuesResponse' => '\\StructType\\GetPickListValuesResponse',
            'ValidatePostalCode' => '\\StructType\\ValidatePostalCode',
            'ValidatePostalCodeResponse' => '\\StructType\\ValidatePostalCodeResponse',
            'SearchEntity' => '\\StructType\\SearchEntity',
            'SearchEntityResponse' => '\\StructType\\SearchEntityResponse',
            'GetEntitiesByTargetDates2' => '\\StructType\\GetEntitiesByTargetDates2',
            'GetEntitiesByTargetDates2Response' => '\\StructType\\GetEntitiesByTargetDates2Response',
            'GetEntitiesByTargetDates' => '\\StructType\\GetEntitiesByTargetDates',
            'GetEntitiesByTargetDatesResponse' => '\\StructType\\GetEntitiesByTargetDatesResponse',
            'GetEntityById' => '\\StructType\\GetEntityById',
            'GetEntityByIdResponse' => '\\StructType\\GetEntityByIdResponse',
            'GetEntityByQuoteId' => '\\StructType\\GetEntityByQuoteId',
            'GetEntityByQuoteIdResponse' => '\\StructType\\GetEntityByQuoteIdResponse',
            'GetAddressById' => '\\StructType\\GetAddressById',
            'GetAddressByIdResponse' => '\\StructType\\GetAddressByIdResponse',
            'UpdateEntity' => '\\StructType\\UpdateEntity',
            'UpdateEntityResponse' => '\\StructType\\UpdateEntityResponse',
            'GetVehicles' => '\\StructType\\GetVehicles',
            'GetVehiclesResponse' => '\\StructType\\GetVehiclesResponse',
            'UpdateVehicle' => '\\StructType\\UpdateVehicle',
            'UpdateVehicleResponse' => '\\StructType\\UpdateVehicleResponse',
            'InsertVehicle' => '\\StructType\\InsertVehicle',
            'InsertVehicleResponse' => '\\StructType\\InsertVehicleResponse',
            'ConvertLeadToContact' => '\\StructType\\ConvertLeadToContact',
            'ConvertLeadToContactResponse' => '\\StructType\\ConvertLeadToContactResponse',
            'ConvertLeadVehicleToContact' => '\\StructType\\ConvertLeadVehicleToContact',
            'ConvertLeadVehicleToContactResponse' => '\\StructType\\ConvertLeadVehicleToContactResponse',
            'GetMostRecentCampaignTarget' => '\\StructType\\GetMostRecentCampaignTarget',
            'GetMostRecentCampaignTargetResponse' => '\\StructType\\GetMostRecentCampaignTargetResponse',
            'GetCampaignTargetById' => '\\StructType\\GetCampaignTargetById',
            'GetCampaignTargetByIdResponse' => '\\StructType\\GetCampaignTargetByIdResponse',
            'InsertCampaignTarget' => '\\StructType\\InsertCampaignTarget',
            'InsertCampaignTargetResponse' => '\\StructType\\InsertCampaignTargetResponse',
            'InsertTargetResponse' => '\\StructType\\InsertTargetResponse',
            'InsertTargetResponseResponse' => '\\StructType\\InsertTargetResponseResponse',
            'GetRates1' => '\\StructType\\GetRates1',
            'GetRates1Response' => '\\StructType\\GetRates1Response',
            'GetRates2' => '\\StructType\\GetRates2',
            'GetRates2Response' => '\\StructType\\GetRates2Response',
            'GetRates3' => '\\StructType\\GetRates3',
            'GetRates3Response' => '\\StructType\\GetRates3Response',
            'GetTermsDocId' => '\\StructType\\GetTermsDocId',
            'GetTermsDocIdResponse' => '\\StructType\\GetTermsDocIdResponse',
            'GetCoverageInfo' => '\\StructType\\GetCoverageInfo',
            'GetCoverageInfoResponse' => '\\StructType\\GetCoverageInfoResponse',
            'InsertQuote' => '\\StructType\\InsertQuote',
            'InsertQuoteResponse' => '\\StructType\\InsertQuoteResponse',
            'InsertQuoteAndEntity' => '\\StructType\\InsertQuoteAndEntity',
            'InsertQuoteAndEntityResponse' => '\\StructType\\InsertQuoteAndEntityResponse',
            'InsertQuotePayment' => '\\StructType\\InsertQuotePayment',
            'InsertQuotePaymentResponse' => '\\StructType\\InsertQuotePaymentResponse',
            'InsertPolicyPayment' => '\\StructType\\InsertPolicyPayment',
            'InsertPolicyPaymentResponse' => '\\StructType\\InsertPolicyPaymentResponse',
            'GetPolicyPayments' => '\\StructType\\GetPolicyPayments',
            'GetPolicyPaymentsResponse' => '\\StructType\\GetPolicyPaymentsResponse',
            'SellQuote' => '\\StructType\\SellQuote',
            'SellQuoteResponse' => '\\StructType\\SellQuoteResponse',
            'CancelPolicy' => '\\StructType\\CancelPolicy',
            'CancelPolicyResponse' => '\\StructType\\CancelPolicyResponse',
            'GetPoliciesByDateRange' => '\\StructType\\GetPoliciesByDateRange',
            'GetPoliciesByDateRangeResponse' => '\\StructType\\GetPoliciesByDateRangeResponse',
            'GetPoliciesByDateRange2' => '\\StructType\\GetPoliciesByDateRange2',
            'GetPoliciesByDateRange2Response' => '\\StructType\\GetPoliciesByDateRange2Response',
            'GetPoliciesByDateRange3' => '\\StructType\\GetPoliciesByDateRange3',
            'GetPoliciesByDateRange3Response' => '\\StructType\\GetPoliciesByDateRange3Response',
            'UpdatePolicy' => '\\StructType\\UpdatePolicy',
            'UpdatePolicyResponse' => '\\StructType\\UpdatePolicyResponse',
            'GetQuoteById' => '\\StructType\\GetQuoteById',
            'GetQuoteByIdResponse' => '\\StructType\\GetQuoteByIdResponse',
            'GetPolicyById' => '\\StructType\\GetPolicyById',
            'GetPolicyByIdResponse' => '\\StructType\\GetPolicyByIdResponse',
            'InsertNote' => '\\StructType\\InsertNote',
            'InsertNoteResponse' => '\\StructType\\InsertNoteResponse',
            'GetNotes' => '\\StructType\\GetNotes',
            'GetNotesResponse' => '\\StructType\\GetNotesResponse',
            'GetDispositions' => '\\StructType\\GetDispositions',
            'GetDispositionsResponse' => '\\StructType\\GetDispositionsResponse',
            'AttachmentFileInfo' => '\\StructType\\AttachmentFileInfo',
            'InsertPhoneCall' => '\\StructType\\InsertPhoneCall',
            'InsertPhoneCallResponse' => '\\StructType\\InsertPhoneCallResponse',
            'GetRecordQueueEntries' => '\\StructType\\GetRecordQueueEntries',
            'GetRecordQueueEntriesResponse' => '\\StructType\\GetRecordQueueEntriesResponse',
            'InsertEntityIntoQueue' => '\\StructType\\InsertEntityIntoQueue',
            'InsertEntityIntoQueueResponse' => '\\StructType\\InsertEntityIntoQueueResponse',
            'RemoveRecordQueueEntry' => '\\StructType\\RemoveRecordQueueEntry',
            'RemoveRecordQueueEntryResponse' => '\\StructType\\RemoveRecordQueueEntryResponse',
            'GetAccounts' => '\\StructType\\GetAccounts',
            'GetAccountsResponse' => '\\StructType\\GetAccountsResponse',
            'GetLeadSources' => '\\StructType\\GetLeadSources',
            'GetLeadSourcesResponse' => '\\StructType\\GetLeadSourcesResponse',
            'GetCampaigns' => '\\StructType\\GetCampaigns',
            'GetCampaignsResponse' => '\\StructType\\GetCampaignsResponse',
            'DecodeVin' => '\\StructType\\DecodeVin',
            'DecodeVinResponse' => '\\StructType\\DecodeVinResponse',
            'GetUsers' => '\\StructType\\GetUsers',
            'GetUsersResponse' => '\\StructType\\GetUsersResponse',
            'GetUserByUserId' => '\\StructType\\GetUserByUserId',
            'GetUserByUserIdResponse' => '\\StructType\\GetUserByUserIdResponse',
            'GetPolicyAttachments' => '\\StructType\\GetPolicyAttachments',
            'GetPolicyAttachmentsResponse' => '\\StructType\\GetPolicyAttachmentsResponse',
            'GetAttachment' => '\\StructType\\GetAttachment',
            'GetAttachmentResponse' => '\\StructType\\GetAttachmentResponse',
            'GetAttachmentDocument' => '\\StructType\\GetAttachmentDocument',
            'GetAttachmentDocumentResponse' => '\\StructType\\GetAttachmentDocumentResponse',
            'GetWebTabResults' => '\\StructType\\GetWebTabResults',
            'GetWebTabResultsResponse' => '\\StructType\\GetWebTabResultsResponse',
            'GetQueryReportResults' => '\\StructType\\GetQueryReportResults',
            'GetQueryReportResultsResponse' => '\\StructType\\GetQueryReportResultsResponse',
        );
    }
}
