<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AltVehicle StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AltVehicle
 * @subpackage Structs
 */
class AltVehicle extends AbstractStructBase
{
    /**
     * The AltVehicleClassId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $AltVehicleClassId;
    /**
     * The AltVehicleId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $AltVehicleId;
    /**
     * The AltVehicleType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AltVehicleType;
    /**
     * The CustomVal1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomVal1;
    /**
     * The CustomVal2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomVal2;
    /**
     * The Disposition
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Disposition;
    /**
     * The EntityId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $EntityId;
    /**
     * The EntityType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EntityType;
    /**
     * The FirstOwner
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $FirstOwner;
    /**
     * The LastServiceDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastServiceDate;
    /**
     * The MakeName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MakeName;
    /**
     * The ModelName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ModelName;
    /**
     * The ModelYear
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $ModelYear;
    /**
     * The Odometer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Odometer;
    /**
     * The OdometerDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OdometerDate;
    /**
     * The PurchaseDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PurchaseDate;
    /**
     * The PurchasePrice
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $PurchasePrice;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Status;
    /**
     * The VIN
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VIN;
    /**
     * The VinVerified
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $VinVerified;
    /**
     * Constructor method for AltVehicle
     * @uses AltVehicle::setAltVehicleClassId()
     * @uses AltVehicle::setAltVehicleId()
     * @uses AltVehicle::setAltVehicleType()
     * @uses AltVehicle::setCustomVal1()
     * @uses AltVehicle::setCustomVal2()
     * @uses AltVehicle::setDisposition()
     * @uses AltVehicle::setEntityId()
     * @uses AltVehicle::setEntityType()
     * @uses AltVehicle::setFirstOwner()
     * @uses AltVehicle::setLastServiceDate()
     * @uses AltVehicle::setMakeName()
     * @uses AltVehicle::setModelName()
     * @uses AltVehicle::setModelYear()
     * @uses AltVehicle::setOdometer()
     * @uses AltVehicle::setOdometerDate()
     * @uses AltVehicle::setPurchaseDate()
     * @uses AltVehicle::setPurchasePrice()
     * @uses AltVehicle::setStatus()
     * @uses AltVehicle::setVIN()
     * @uses AltVehicle::setVinVerified()
     * @param int $altVehicleClassId
     * @param int $altVehicleId
     * @param string $altVehicleType
     * @param string $customVal1
     * @param string $customVal2
     * @param string $disposition
     * @param int $entityId
     * @param string $entityType
     * @param bool $firstOwner
     * @param string $lastServiceDate
     * @param string $makeName
     * @param string $modelName
     * @param int $modelYear
     * @param int $odometer
     * @param string $odometerDate
     * @param string $purchaseDate
     * @param float $purchasePrice
     * @param string $status
     * @param string $vIN
     * @param bool $vinVerified
     */
    public function __construct($altVehicleClassId = null, $altVehicleId = null, $altVehicleType = null, $customVal1 = null, $customVal2 = null, $disposition = null, $entityId = null, $entityType = null, $firstOwner = null, $lastServiceDate = null, $makeName = null, $modelName = null, $modelYear = null, $odometer = null, $odometerDate = null, $purchaseDate = null, $purchasePrice = null, $status = null, $vIN = null, $vinVerified = null)
    {
        $this
            ->setAltVehicleClassId($altVehicleClassId)
            ->setAltVehicleId($altVehicleId)
            ->setAltVehicleType($altVehicleType)
            ->setCustomVal1($customVal1)
            ->setCustomVal2($customVal2)
            ->setDisposition($disposition)
            ->setEntityId($entityId)
            ->setEntityType($entityType)
            ->setFirstOwner($firstOwner)
            ->setLastServiceDate($lastServiceDate)
            ->setMakeName($makeName)
            ->setModelName($modelName)
            ->setModelYear($modelYear)
            ->setOdometer($odometer)
            ->setOdometerDate($odometerDate)
            ->setPurchaseDate($purchaseDate)
            ->setPurchasePrice($purchasePrice)
            ->setStatus($status)
            ->setVIN($vIN)
            ->setVinVerified($vinVerified);
    }
    /**
     * Get AltVehicleClassId value
     * @return int|null
     */
    public function getAltVehicleClassId()
    {
        return $this->AltVehicleClassId;
    }
    /**
     * Set AltVehicleClassId value
     * @param int $altVehicleClassId
     * @return \StructType\AltVehicle
     */
    public function setAltVehicleClassId($altVehicleClassId = null)
    {
        // validation for constraint: int
        if (!is_null($altVehicleClassId) && !(is_int($altVehicleClassId) || ctype_digit($altVehicleClassId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($altVehicleClassId, true), gettype($altVehicleClassId)), __LINE__);
        }
        $this->AltVehicleClassId = $altVehicleClassId;
        return $this;
    }
    /**
     * Get AltVehicleId value
     * @return int|null
     */
    public function getAltVehicleId()
    {
        return $this->AltVehicleId;
    }
    /**
     * Set AltVehicleId value
     * @param int $altVehicleId
     * @return \StructType\AltVehicle
     */
    public function setAltVehicleId($altVehicleId = null)
    {
        // validation for constraint: int
        if (!is_null($altVehicleId) && !(is_int($altVehicleId) || ctype_digit($altVehicleId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($altVehicleId, true), gettype($altVehicleId)), __LINE__);
        }
        $this->AltVehicleId = $altVehicleId;
        return $this;
    }
    /**
     * Get AltVehicleType value
     * @return string|null
     */
    public function getAltVehicleType()
    {
        return $this->AltVehicleType;
    }
    /**
     * Set AltVehicleType value
     * @uses \EnumType\VehicleType::valueIsValid()
     * @uses \EnumType\VehicleType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $altVehicleType
     * @return \StructType\AltVehicle
     */
    public function setAltVehicleType($altVehicleType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\VehicleType::valueIsValid($altVehicleType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\VehicleType', is_array($altVehicleType) ? implode(', ', $altVehicleType) : var_export($altVehicleType, true), implode(', ', \EnumType\VehicleType::getValidValues())), __LINE__);
        }
        $this->AltVehicleType = $altVehicleType;
        return $this;
    }
    /**
     * Get CustomVal1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomVal1()
    {
        return isset($this->CustomVal1) ? $this->CustomVal1 : null;
    }
    /**
     * Set CustomVal1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customVal1
     * @return \StructType\AltVehicle
     */
    public function setCustomVal1($customVal1 = null)
    {
        // validation for constraint: string
        if (!is_null($customVal1) && !is_string($customVal1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customVal1, true), gettype($customVal1)), __LINE__);
        }
        if (is_null($customVal1) || (is_array($customVal1) && empty($customVal1))) {
            unset($this->CustomVal1);
        } else {
            $this->CustomVal1 = $customVal1;
        }
        return $this;
    }
    /**
     * Get CustomVal2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomVal2()
    {
        return isset($this->CustomVal2) ? $this->CustomVal2 : null;
    }
    /**
     * Set CustomVal2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customVal2
     * @return \StructType\AltVehicle
     */
    public function setCustomVal2($customVal2 = null)
    {
        // validation for constraint: string
        if (!is_null($customVal2) && !is_string($customVal2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customVal2, true), gettype($customVal2)), __LINE__);
        }
        if (is_null($customVal2) || (is_array($customVal2) && empty($customVal2))) {
            unset($this->CustomVal2);
        } else {
            $this->CustomVal2 = $customVal2;
        }
        return $this;
    }
    /**
     * Get Disposition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDisposition()
    {
        return isset($this->Disposition) ? $this->Disposition : null;
    }
    /**
     * Set Disposition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $disposition
     * @return \StructType\AltVehicle
     */
    public function setDisposition($disposition = null)
    {
        // validation for constraint: string
        if (!is_null($disposition) && !is_string($disposition)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($disposition, true), gettype($disposition)), __LINE__);
        }
        if (is_null($disposition) || (is_array($disposition) && empty($disposition))) {
            unset($this->Disposition);
        } else {
            $this->Disposition = $disposition;
        }
        return $this;
    }
    /**
     * Get EntityId value
     * @return int|null
     */
    public function getEntityId()
    {
        return $this->EntityId;
    }
    /**
     * Set EntityId value
     * @param int $entityId
     * @return \StructType\AltVehicle
     */
    public function setEntityId($entityId = null)
    {
        // validation for constraint: int
        if (!is_null($entityId) && !(is_int($entityId) || ctype_digit($entityId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($entityId, true), gettype($entityId)), __LINE__);
        }
        $this->EntityId = $entityId;
        return $this;
    }
    /**
     * Get EntityType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEntityType()
    {
        return isset($this->EntityType) ? $this->EntityType : null;
    }
    /**
     * Set EntityType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $entityType
     * @return \StructType\AltVehicle
     */
    public function setEntityType($entityType = null)
    {
        // validation for constraint: string
        if (!is_null($entityType) && !is_string($entityType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($entityType, true), gettype($entityType)), __LINE__);
        }
        if (is_null($entityType) || (is_array($entityType) && empty($entityType))) {
            unset($this->EntityType);
        } else {
            $this->EntityType = $entityType;
        }
        return $this;
    }
    /**
     * Get FirstOwner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getFirstOwner()
    {
        return isset($this->FirstOwner) ? $this->FirstOwner : null;
    }
    /**
     * Set FirstOwner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $firstOwner
     * @return \StructType\AltVehicle
     */
    public function setFirstOwner($firstOwner = null)
    {
        // validation for constraint: boolean
        if (!is_null($firstOwner) && !is_bool($firstOwner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($firstOwner, true), gettype($firstOwner)), __LINE__);
        }
        if (is_null($firstOwner) || (is_array($firstOwner) && empty($firstOwner))) {
            unset($this->FirstOwner);
        } else {
            $this->FirstOwner = $firstOwner;
        }
        return $this;
    }
    /**
     * Get LastServiceDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastServiceDate()
    {
        return isset($this->LastServiceDate) ? $this->LastServiceDate : null;
    }
    /**
     * Set LastServiceDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastServiceDate
     * @return \StructType\AltVehicle
     */
    public function setLastServiceDate($lastServiceDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastServiceDate) && !is_string($lastServiceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastServiceDate, true), gettype($lastServiceDate)), __LINE__);
        }
        if (is_null($lastServiceDate) || (is_array($lastServiceDate) && empty($lastServiceDate))) {
            unset($this->LastServiceDate);
        } else {
            $this->LastServiceDate = $lastServiceDate;
        }
        return $this;
    }
    /**
     * Get MakeName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMakeName()
    {
        return isset($this->MakeName) ? $this->MakeName : null;
    }
    /**
     * Set MakeName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $makeName
     * @return \StructType\AltVehicle
     */
    public function setMakeName($makeName = null)
    {
        // validation for constraint: string
        if (!is_null($makeName) && !is_string($makeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($makeName, true), gettype($makeName)), __LINE__);
        }
        if (is_null($makeName) || (is_array($makeName) && empty($makeName))) {
            unset($this->MakeName);
        } else {
            $this->MakeName = $makeName;
        }
        return $this;
    }
    /**
     * Get ModelName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getModelName()
    {
        return isset($this->ModelName) ? $this->ModelName : null;
    }
    /**
     * Set ModelName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $modelName
     * @return \StructType\AltVehicle
     */
    public function setModelName($modelName = null)
    {
        // validation for constraint: string
        if (!is_null($modelName) && !is_string($modelName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modelName, true), gettype($modelName)), __LINE__);
        }
        if (is_null($modelName) || (is_array($modelName) && empty($modelName))) {
            unset($this->ModelName);
        } else {
            $this->ModelName = $modelName;
        }
        return $this;
    }
    /**
     * Get ModelYear value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getModelYear()
    {
        return isset($this->ModelYear) ? $this->ModelYear : null;
    }
    /**
     * Set ModelYear value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $modelYear
     * @return \StructType\AltVehicle
     */
    public function setModelYear($modelYear = null)
    {
        // validation for constraint: int
        if (!is_null($modelYear) && !(is_int($modelYear) || ctype_digit($modelYear))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($modelYear, true), gettype($modelYear)), __LINE__);
        }
        if (is_null($modelYear) || (is_array($modelYear) && empty($modelYear))) {
            unset($this->ModelYear);
        } else {
            $this->ModelYear = $modelYear;
        }
        return $this;
    }
    /**
     * Get Odometer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getOdometer()
    {
        return isset($this->Odometer) ? $this->Odometer : null;
    }
    /**
     * Set Odometer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $odometer
     * @return \StructType\AltVehicle
     */
    public function setOdometer($odometer = null)
    {
        // validation for constraint: int
        if (!is_null($odometer) && !(is_int($odometer) || ctype_digit($odometer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($odometer, true), gettype($odometer)), __LINE__);
        }
        if (is_null($odometer) || (is_array($odometer) && empty($odometer))) {
            unset($this->Odometer);
        } else {
            $this->Odometer = $odometer;
        }
        return $this;
    }
    /**
     * Get OdometerDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOdometerDate()
    {
        return isset($this->OdometerDate) ? $this->OdometerDate : null;
    }
    /**
     * Set OdometerDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $odometerDate
     * @return \StructType\AltVehicle
     */
    public function setOdometerDate($odometerDate = null)
    {
        // validation for constraint: string
        if (!is_null($odometerDate) && !is_string($odometerDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($odometerDate, true), gettype($odometerDate)), __LINE__);
        }
        if (is_null($odometerDate) || (is_array($odometerDate) && empty($odometerDate))) {
            unset($this->OdometerDate);
        } else {
            $this->OdometerDate = $odometerDate;
        }
        return $this;
    }
    /**
     * Get PurchaseDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPurchaseDate()
    {
        return isset($this->PurchaseDate) ? $this->PurchaseDate : null;
    }
    /**
     * Set PurchaseDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $purchaseDate
     * @return \StructType\AltVehicle
     */
    public function setPurchaseDate($purchaseDate = null)
    {
        // validation for constraint: string
        if (!is_null($purchaseDate) && !is_string($purchaseDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($purchaseDate, true), gettype($purchaseDate)), __LINE__);
        }
        if (is_null($purchaseDate) || (is_array($purchaseDate) && empty($purchaseDate))) {
            unset($this->PurchaseDate);
        } else {
            $this->PurchaseDate = $purchaseDate;
        }
        return $this;
    }
    /**
     * Get PurchasePrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getPurchasePrice()
    {
        return isset($this->PurchasePrice) ? $this->PurchasePrice : null;
    }
    /**
     * Set PurchasePrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $purchasePrice
     * @return \StructType\AltVehicle
     */
    public function setPurchasePrice($purchasePrice = null)
    {
        // validation for constraint: float
        if (!is_null($purchasePrice) && !(is_float($purchasePrice) || is_numeric($purchasePrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($purchasePrice, true), gettype($purchasePrice)), __LINE__);
        }
        if (is_null($purchasePrice) || (is_array($purchasePrice) && empty($purchasePrice))) {
            unset($this->PurchasePrice);
        } else {
            $this->PurchasePrice = $purchasePrice;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $status
     * @return \StructType\AltVehicle
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get VIN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVIN()
    {
        return isset($this->VIN) ? $this->VIN : null;
    }
    /**
     * Set VIN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vIN
     * @return \StructType\AltVehicle
     */
    public function setVIN($vIN = null)
    {
        // validation for constraint: string
        if (!is_null($vIN) && !is_string($vIN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vIN, true), gettype($vIN)), __LINE__);
        }
        if (is_null($vIN) || (is_array($vIN) && empty($vIN))) {
            unset($this->VIN);
        } else {
            $this->VIN = $vIN;
        }
        return $this;
    }
    /**
     * Get VinVerified value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getVinVerified()
    {
        return isset($this->VinVerified) ? $this->VinVerified : null;
    }
    /**
     * Set VinVerified value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $vinVerified
     * @return \StructType\AltVehicle
     */
    public function setVinVerified($vinVerified = null)
    {
        // validation for constraint: boolean
        if (!is_null($vinVerified) && !is_bool($vinVerified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($vinVerified, true), gettype($vinVerified)), __LINE__);
        }
        if (is_null($vinVerified) || (is_array($vinVerified) && empty($vinVerified))) {
            unset($this->VinVerified);
        } else {
            $this->VinVerified = $vinVerified;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AltVehicle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
