<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AttachmentFileInfo StructType
 * @subpackage Structs
 */
class AttachmentFileInfo extends AbstractStructBase
{
    /**
     * The FileByteStream
     * Meta information extracted from the WSDL
     * - base: xs:base64Binary
     * @var string
     */
    public $FileByteStream;
    /**
     * Constructor method for AttachmentFileInfo
     * @uses AttachmentFileInfo::setFileByteStream()
     * @param string $fileByteStream
     */
    public function __construct($fileByteStream = null)
    {
        $this
            ->setFileByteStream($fileByteStream);
    }
    /**
     * Get FileByteStream value
     * @return string|null
     */
    public function getFileByteStream()
    {
        return $this->FileByteStream;
    }
    /**
     * Set FileByteStream value
     * @param string $fileByteStream
     * @return \StructType\AttachmentFileInfo
     */
    public function setFileByteStream($fileByteStream = null)
    {
        // validation for constraint: string
        if (!is_null($fileByteStream) && !is_string($fileByteStream)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fileByteStream, true), gettype($fileByteStream)), __LINE__);
        }
        $this->FileByteStream = $fileByteStream;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AttachmentFileInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
