<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactVehicle StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ContactVehicle
 * @subpackage Structs
 */
class ContactVehicle extends AbstractStructBase
{
    /**
     * The ContactId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ContactId;
    /**
     * The Disposition
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Disposition;
    /**
     * The LastServiceDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastServiceDate;
    /**
     * The ModelYear
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $ModelYear;
    /**
     * The Odometer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Odometer;
    /**
     * The OdometerDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OdometerDate;
    /**
     * The PurchaseDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PurchaseDate;
    /**
     * The PurchasePrice
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $PurchasePrice;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Status;
    /**
     * The VIN
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $VIN;
    /**
     * The VehicleId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $VehicleId;
    /**
     * The VehicleTrimId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $VehicleTrimId;
    /**
     * The VinVerified
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $VinVerified;
    /**
     * Constructor method for ContactVehicle
     * @uses ContactVehicle::setContactId()
     * @uses ContactVehicle::setDisposition()
     * @uses ContactVehicle::setLastServiceDate()
     * @uses ContactVehicle::setModelYear()
     * @uses ContactVehicle::setOdometer()
     * @uses ContactVehicle::setOdometerDate()
     * @uses ContactVehicle::setPurchaseDate()
     * @uses ContactVehicle::setPurchasePrice()
     * @uses ContactVehicle::setStatus()
     * @uses ContactVehicle::setVIN()
     * @uses ContactVehicle::setVehicleId()
     * @uses ContactVehicle::setVehicleTrimId()
     * @uses ContactVehicle::setVinVerified()
     * @param int $contactId
     * @param string $disposition
     * @param string $lastServiceDate
     * @param int $modelYear
     * @param int $odometer
     * @param string $odometerDate
     * @param string $purchaseDate
     * @param float $purchasePrice
     * @param string $status
     * @param string $vIN
     * @param int $vehicleId
     * @param int $vehicleTrimId
     * @param bool $vinVerified
     */
    public function __construct($contactId = null, $disposition = null, $lastServiceDate = null, $modelYear = null, $odometer = null, $odometerDate = null, $purchaseDate = null, $purchasePrice = null, $status = null, $vIN = null, $vehicleId = null, $vehicleTrimId = null, $vinVerified = null)
    {
        $this
            ->setContactId($contactId)
            ->setDisposition($disposition)
            ->setLastServiceDate($lastServiceDate)
            ->setModelYear($modelYear)
            ->setOdometer($odometer)
            ->setOdometerDate($odometerDate)
            ->setPurchaseDate($purchaseDate)
            ->setPurchasePrice($purchasePrice)
            ->setStatus($status)
            ->setVIN($vIN)
            ->setVehicleId($vehicleId)
            ->setVehicleTrimId($vehicleTrimId)
            ->setVinVerified($vinVerified);
    }
    /**
     * Get ContactId value
     * @return int|null
     */
    public function getContactId()
    {
        return $this->ContactId;
    }
    /**
     * Set ContactId value
     * @param int $contactId
     * @return \StructType\ContactVehicle
     */
    public function setContactId($contactId = null)
    {
        // validation for constraint: int
        if (!is_null($contactId) && !(is_int($contactId) || ctype_digit($contactId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($contactId, true), gettype($contactId)), __LINE__);
        }
        $this->ContactId = $contactId;
        return $this;
    }
    /**
     * Get Disposition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDisposition()
    {
        return isset($this->Disposition) ? $this->Disposition : null;
    }
    /**
     * Set Disposition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $disposition
     * @return \StructType\ContactVehicle
     */
    public function setDisposition($disposition = null)
    {
        // validation for constraint: string
        if (!is_null($disposition) && !is_string($disposition)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($disposition, true), gettype($disposition)), __LINE__);
        }
        if (is_null($disposition) || (is_array($disposition) && empty($disposition))) {
            unset($this->Disposition);
        } else {
            $this->Disposition = $disposition;
        }
        return $this;
    }
    /**
     * Get LastServiceDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastServiceDate()
    {
        return isset($this->LastServiceDate) ? $this->LastServiceDate : null;
    }
    /**
     * Set LastServiceDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastServiceDate
     * @return \StructType\ContactVehicle
     */
    public function setLastServiceDate($lastServiceDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastServiceDate) && !is_string($lastServiceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastServiceDate, true), gettype($lastServiceDate)), __LINE__);
        }
        if (is_null($lastServiceDate) || (is_array($lastServiceDate) && empty($lastServiceDate))) {
            unset($this->LastServiceDate);
        } else {
            $this->LastServiceDate = $lastServiceDate;
        }
        return $this;
    }
    /**
     * Get ModelYear value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getModelYear()
    {
        return isset($this->ModelYear) ? $this->ModelYear : null;
    }
    /**
     * Set ModelYear value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $modelYear
     * @return \StructType\ContactVehicle
     */
    public function setModelYear($modelYear = null)
    {
        // validation for constraint: int
        if (!is_null($modelYear) && !(is_int($modelYear) || ctype_digit($modelYear))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($modelYear, true), gettype($modelYear)), __LINE__);
        }
        if (is_null($modelYear) || (is_array($modelYear) && empty($modelYear))) {
            unset($this->ModelYear);
        } else {
            $this->ModelYear = $modelYear;
        }
        return $this;
    }
    /**
     * Get Odometer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getOdometer()
    {
        return isset($this->Odometer) ? $this->Odometer : null;
    }
    /**
     * Set Odometer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $odometer
     * @return \StructType\ContactVehicle
     */
    public function setOdometer($odometer = null)
    {
        // validation for constraint: int
        if (!is_null($odometer) && !(is_int($odometer) || ctype_digit($odometer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($odometer, true), gettype($odometer)), __LINE__);
        }
        if (is_null($odometer) || (is_array($odometer) && empty($odometer))) {
            unset($this->Odometer);
        } else {
            $this->Odometer = $odometer;
        }
        return $this;
    }
    /**
     * Get OdometerDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOdometerDate()
    {
        return isset($this->OdometerDate) ? $this->OdometerDate : null;
    }
    /**
     * Set OdometerDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $odometerDate
     * @return \StructType\ContactVehicle
     */
    public function setOdometerDate($odometerDate = null)
    {
        // validation for constraint: string
        if (!is_null($odometerDate) && !is_string($odometerDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($odometerDate, true), gettype($odometerDate)), __LINE__);
        }
        if (is_null($odometerDate) || (is_array($odometerDate) && empty($odometerDate))) {
            unset($this->OdometerDate);
        } else {
            $this->OdometerDate = $odometerDate;
        }
        return $this;
    }
    /**
     * Get PurchaseDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPurchaseDate()
    {
        return isset($this->PurchaseDate) ? $this->PurchaseDate : null;
    }
    /**
     * Set PurchaseDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $purchaseDate
     * @return \StructType\ContactVehicle
     */
    public function setPurchaseDate($purchaseDate = null)
    {
        // validation for constraint: string
        if (!is_null($purchaseDate) && !is_string($purchaseDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($purchaseDate, true), gettype($purchaseDate)), __LINE__);
        }
        if (is_null($purchaseDate) || (is_array($purchaseDate) && empty($purchaseDate))) {
            unset($this->PurchaseDate);
        } else {
            $this->PurchaseDate = $purchaseDate;
        }
        return $this;
    }
    /**
     * Get PurchasePrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getPurchasePrice()
    {
        return isset($this->PurchasePrice) ? $this->PurchasePrice : null;
    }
    /**
     * Set PurchasePrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $purchasePrice
     * @return \StructType\ContactVehicle
     */
    public function setPurchasePrice($purchasePrice = null)
    {
        // validation for constraint: float
        if (!is_null($purchasePrice) && !(is_float($purchasePrice) || is_numeric($purchasePrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($purchasePrice, true), gettype($purchasePrice)), __LINE__);
        }
        if (is_null($purchasePrice) || (is_array($purchasePrice) && empty($purchasePrice))) {
            unset($this->PurchasePrice);
        } else {
            $this->PurchasePrice = $purchasePrice;
        }
        return $this;
    }
    /**
     * Get Status value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStatus()
    {
        return isset($this->Status) ? $this->Status : null;
    }
    /**
     * Set Status value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $status
     * @return \StructType\ContactVehicle
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        if (is_null($status) || (is_array($status) && empty($status))) {
            unset($this->Status);
        } else {
            $this->Status = $status;
        }
        return $this;
    }
    /**
     * Get VIN value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVIN()
    {
        return isset($this->VIN) ? $this->VIN : null;
    }
    /**
     * Set VIN value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vIN
     * @return \StructType\ContactVehicle
     */
    public function setVIN($vIN = null)
    {
        // validation for constraint: string
        if (!is_null($vIN) && !is_string($vIN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vIN, true), gettype($vIN)), __LINE__);
        }
        if (is_null($vIN) || (is_array($vIN) && empty($vIN))) {
            unset($this->VIN);
        } else {
            $this->VIN = $vIN;
        }
        return $this;
    }
    /**
     * Get VehicleId value
     * @return int|null
     */
    public function getVehicleId()
    {
        return $this->VehicleId;
    }
    /**
     * Set VehicleId value
     * @param int $vehicleId
     * @return \StructType\ContactVehicle
     */
    public function setVehicleId($vehicleId = null)
    {
        // validation for constraint: int
        if (!is_null($vehicleId) && !(is_int($vehicleId) || ctype_digit($vehicleId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($vehicleId, true), gettype($vehicleId)), __LINE__);
        }
        $this->VehicleId = $vehicleId;
        return $this;
    }
    /**
     * Get VehicleTrimId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getVehicleTrimId()
    {
        return isset($this->VehicleTrimId) ? $this->VehicleTrimId : null;
    }
    /**
     * Set VehicleTrimId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $vehicleTrimId
     * @return \StructType\ContactVehicle
     */
    public function setVehicleTrimId($vehicleTrimId = null)
    {
        // validation for constraint: int
        if (!is_null($vehicleTrimId) && !(is_int($vehicleTrimId) || ctype_digit($vehicleTrimId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($vehicleTrimId, true), gettype($vehicleTrimId)), __LINE__);
        }
        if (is_null($vehicleTrimId) || (is_array($vehicleTrimId) && empty($vehicleTrimId))) {
            unset($this->VehicleTrimId);
        } else {
            $this->VehicleTrimId = $vehicleTrimId;
        }
        return $this;
    }
    /**
     * Get VinVerified value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getVinVerified()
    {
        return isset($this->VinVerified) ? $this->VinVerified : null;
    }
    /**
     * Set VinVerified value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $vinVerified
     * @return \StructType\ContactVehicle
     */
    public function setVinVerified($vinVerified = null)
    {
        // validation for constraint: boolean
        if (!is_null($vinVerified) && !is_bool($vinVerified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($vinVerified, true), gettype($vinVerified)), __LINE__);
        }
        if (is_null($vinVerified) || (is_array($vinVerified) && empty($vinVerified))) {
            unset($this->VinVerified);
        } else {
            $this->VinVerified = $vinVerified;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactVehicle
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
