<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DecodeVin StructType
 * @subpackage Structs
 */
class DecodeVin extends AbstractStructBase
{
    /**
     * The vin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $vin;
    /**
     * Constructor method for DecodeVin
     * @uses DecodeVin::setVin()
     * @param string $vin
     */
    public function __construct($vin = null)
    {
        $this
            ->setVin($vin);
    }
    /**
     * Get vin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVin()
    {
        return isset($this->vin) ? $this->vin : null;
    }
    /**
     * Set vin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vin
     * @return \StructType\DecodeVin
     */
    public function setVin($vin = null)
    {
        // validation for constraint: string
        if (!is_null($vin) && !is_string($vin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vin, true), gettype($vin)), __LINE__);
        }
        if (is_null($vin) || (is_array($vin) && empty($vin))) {
            unset($this->vin);
        } else {
            $this->vin = $vin;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DecodeVin
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
