<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAttachmentDocument StructType
 * @subpackage Structs
 */
class GetAttachmentDocument extends AbstractStructBase
{
    /**
     * The attachId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $attachId;
    /**
     * Constructor method for GetAttachmentDocument
     * @uses GetAttachmentDocument::setAttachId()
     * @param int $attachId
     */
    public function __construct($attachId = null)
    {
        $this
            ->setAttachId($attachId);
    }
    /**
     * Get attachId value
     * @return int|null
     */
    public function getAttachId()
    {
        return $this->attachId;
    }
    /**
     * Set attachId value
     * @param int $attachId
     * @return \StructType\GetAttachmentDocument
     */
    public function setAttachId($attachId = null)
    {
        // validation for constraint: int
        if (!is_null($attachId) && !(is_int($attachId) || ctype_digit($attachId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($attachId, true), gettype($attachId)), __LINE__);
        }
        $this->attachId = $attachId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetAttachmentDocument
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
