<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCampaigns StructType
 * @subpackage Structs
 */
class GetCampaigns extends AbstractStructBase
{
    /**
     * The typeFilters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $typeFilters;
    /**
     * The leadSourceFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $leadSourceFilter;
    /**
     * The affiliateFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $affiliateFilter;
    /**
     * The externalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $externalId;
    /**
     * Constructor method for GetCampaigns
     * @uses GetCampaigns::setTypeFilters()
     * @uses GetCampaigns::setLeadSourceFilter()
     * @uses GetCampaigns::setAffiliateFilter()
     * @uses GetCampaigns::setExternalId()
     * @param \ArrayType\ArrayOfstring $typeFilters
     * @param int $leadSourceFilter
     * @param int $affiliateFilter
     * @param string $externalId
     */
    public function __construct(\ArrayType\ArrayOfstring $typeFilters = null, $leadSourceFilter = null, $affiliateFilter = null, $externalId = null)
    {
        $this
            ->setTypeFilters($typeFilters)
            ->setLeadSourceFilter($leadSourceFilter)
            ->setAffiliateFilter($affiliateFilter)
            ->setExternalId($externalId);
    }
    /**
     * Get typeFilters value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getTypeFilters()
    {
        return isset($this->typeFilters) ? $this->typeFilters : null;
    }
    /**
     * Set typeFilters value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $typeFilters
     * @return \StructType\GetCampaigns
     */
    public function setTypeFilters(\ArrayType\ArrayOfstring $typeFilters = null)
    {
        if (is_null($typeFilters) || (is_array($typeFilters) && empty($typeFilters))) {
            unset($this->typeFilters);
        } else {
            $this->typeFilters = $typeFilters;
        }
        return $this;
    }
    /**
     * Get leadSourceFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getLeadSourceFilter()
    {
        return isset($this->leadSourceFilter) ? $this->leadSourceFilter : null;
    }
    /**
     * Set leadSourceFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $leadSourceFilter
     * @return \StructType\GetCampaigns
     */
    public function setLeadSourceFilter($leadSourceFilter = null)
    {
        // validation for constraint: int
        if (!is_null($leadSourceFilter) && !(is_int($leadSourceFilter) || ctype_digit($leadSourceFilter))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($leadSourceFilter, true), gettype($leadSourceFilter)), __LINE__);
        }
        if (is_null($leadSourceFilter) || (is_array($leadSourceFilter) && empty($leadSourceFilter))) {
            unset($this->leadSourceFilter);
        } else {
            $this->leadSourceFilter = $leadSourceFilter;
        }
        return $this;
    }
    /**
     * Get affiliateFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAffiliateFilter()
    {
        return isset($this->affiliateFilter) ? $this->affiliateFilter : null;
    }
    /**
     * Set affiliateFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $affiliateFilter
     * @return \StructType\GetCampaigns
     */
    public function setAffiliateFilter($affiliateFilter = null)
    {
        // validation for constraint: int
        if (!is_null($affiliateFilter) && !(is_int($affiliateFilter) || ctype_digit($affiliateFilter))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($affiliateFilter, true), gettype($affiliateFilter)), __LINE__);
        }
        if (is_null($affiliateFilter) || (is_array($affiliateFilter) && empty($affiliateFilter))) {
            unset($this->affiliateFilter);
        } else {
            $this->affiliateFilter = $affiliateFilter;
        }
        return $this;
    }
    /**
     * Get externalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalId()
    {
        return isset($this->externalId) ? $this->externalId : null;
    }
    /**
     * Set externalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalId
     * @return \StructType\GetCampaigns
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: string
        if (!is_null($externalId) && !is_string($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalId, true), gettype($externalId)), __LINE__);
        }
        if (is_null($externalId) || (is_array($externalId) && empty($externalId))) {
            unset($this->externalId);
        } else {
            $this->externalId = $externalId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCampaigns
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
