<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCoverageInfo StructType
 * @subpackage Structs
 */
class GetCoverageInfo extends AbstractStructBase
{
    /**
     * The coverageId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $coverageId;
    /**
     * Constructor method for GetCoverageInfo
     * @uses GetCoverageInfo::setCoverageId()
     * @param int $coverageId
     */
    public function __construct($coverageId = null)
    {
        $this
            ->setCoverageId($coverageId);
    }
    /**
     * Get coverageId value
     * @return int|null
     */
    public function getCoverageId()
    {
        return $this->coverageId;
    }
    /**
     * Set coverageId value
     * @param int $coverageId
     * @return \StructType\GetCoverageInfo
     */
    public function setCoverageId($coverageId = null)
    {
        // validation for constraint: int
        if (!is_null($coverageId) && !(is_int($coverageId) || ctype_digit($coverageId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($coverageId, true), gettype($coverageId)), __LINE__);
        }
        $this->coverageId = $coverageId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCoverageInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
