<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPoliciesByDateRange3 StructType
 * @subpackage Structs
 */
class GetPoliciesByDateRange3 extends AbstractStructBase
{
    /**
     * The startDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $startDate;
    /**
     * The endDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $endDate;
    /**
     * The userIdFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $userIdFilter;
    /**
     * The statusFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $statusFilter;
    /**
     * The dpStatusFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $dpStatusFilter;
    /**
     * The fundingStatusFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $fundingStatusFilter;
    /**
     * Constructor method for GetPoliciesByDateRange3
     * @uses GetPoliciesByDateRange3::setStartDate()
     * @uses GetPoliciesByDateRange3::setEndDate()
     * @uses GetPoliciesByDateRange3::setUserIdFilter()
     * @uses GetPoliciesByDateRange3::setStatusFilter()
     * @uses GetPoliciesByDateRange3::setDpStatusFilter()
     * @uses GetPoliciesByDateRange3::setFundingStatusFilter()
     * @param string $startDate
     * @param string $endDate
     * @param string $userIdFilter
     * @param \ArrayType\ArrayOfstring $statusFilter
     * @param \ArrayType\ArrayOfstring $dpStatusFilter
     * @param \ArrayType\ArrayOfstring $fundingStatusFilter
     */
    public function __construct($startDate = null, $endDate = null, $userIdFilter = null, \ArrayType\ArrayOfstring $statusFilter = null, \ArrayType\ArrayOfstring $dpStatusFilter = null, \ArrayType\ArrayOfstring $fundingStatusFilter = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setUserIdFilter($userIdFilter)
            ->setStatusFilter($statusFilter)
            ->setDpStatusFilter($dpStatusFilter)
            ->setFundingStatusFilter($fundingStatusFilter);
    }
    /**
     * Get startDate value
     * @return string|null
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set startDate value
     * @param string $startDate
     * @return \StructType\GetPoliciesByDateRange3
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDate, true), gettype($startDate)), __LINE__);
        }
        $this->startDate = $startDate;
        return $this;
    }
    /**
     * Get endDate value
     * @return string|null
     */
    public function getEndDate()
    {
        return $this->endDate;
    }
    /**
     * Set endDate value
     * @param string $endDate
     * @return \StructType\GetPoliciesByDateRange3
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        $this->endDate = $endDate;
        return $this;
    }
    /**
     * Get userIdFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserIdFilter()
    {
        return isset($this->userIdFilter) ? $this->userIdFilter : null;
    }
    /**
     * Set userIdFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userIdFilter
     * @return \StructType\GetPoliciesByDateRange3
     */
    public function setUserIdFilter($userIdFilter = null)
    {
        // validation for constraint: string
        if (!is_null($userIdFilter) && !is_string($userIdFilter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userIdFilter, true), gettype($userIdFilter)), __LINE__);
        }
        if (is_null($userIdFilter) || (is_array($userIdFilter) && empty($userIdFilter))) {
            unset($this->userIdFilter);
        } else {
            $this->userIdFilter = $userIdFilter;
        }
        return $this;
    }
    /**
     * Get statusFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getStatusFilter()
    {
        return isset($this->statusFilter) ? $this->statusFilter : null;
    }
    /**
     * Set statusFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $statusFilter
     * @return \StructType\GetPoliciesByDateRange3
     */
    public function setStatusFilter(\ArrayType\ArrayOfstring $statusFilter = null)
    {
        if (is_null($statusFilter) || (is_array($statusFilter) && empty($statusFilter))) {
            unset($this->statusFilter);
        } else {
            $this->statusFilter = $statusFilter;
        }
        return $this;
    }
    /**
     * Get dpStatusFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getDpStatusFilter()
    {
        return isset($this->dpStatusFilter) ? $this->dpStatusFilter : null;
    }
    /**
     * Set dpStatusFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $dpStatusFilter
     * @return \StructType\GetPoliciesByDateRange3
     */
    public function setDpStatusFilter(\ArrayType\ArrayOfstring $dpStatusFilter = null)
    {
        if (is_null($dpStatusFilter) || (is_array($dpStatusFilter) && empty($dpStatusFilter))) {
            unset($this->dpStatusFilter);
        } else {
            $this->dpStatusFilter = $dpStatusFilter;
        }
        return $this;
    }
    /**
     * Get fundingStatusFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getFundingStatusFilter()
    {
        return isset($this->fundingStatusFilter) ? $this->fundingStatusFilter : null;
    }
    /**
     * Set fundingStatusFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $fundingStatusFilter
     * @return \StructType\GetPoliciesByDateRange3
     */
    public function setFundingStatusFilter(\ArrayType\ArrayOfstring $fundingStatusFilter = null)
    {
        if (is_null($fundingStatusFilter) || (is_array($fundingStatusFilter) && empty($fundingStatusFilter))) {
            unset($this->fundingStatusFilter);
        } else {
            $this->fundingStatusFilter = $fundingStatusFilter;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPoliciesByDateRange3
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
