<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTermsDocId StructType
 * @subpackage Structs
 */
class GetTermsDocId extends AbstractStructBase
{
    /**
     * The coverageId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $coverageId;
    /**
     * The zip
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $zip;
    /**
     * The stateProvince
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $stateProvince;
    /**
     * Constructor method for GetTermsDocId
     * @uses GetTermsDocId::setCoverageId()
     * @uses GetTermsDocId::setZip()
     * @uses GetTermsDocId::setStateProvince()
     * @param int $coverageId
     * @param string $zip
     * @param string $stateProvince
     */
    public function __construct($coverageId = null, $zip = null, $stateProvince = null)
    {
        $this
            ->setCoverageId($coverageId)
            ->setZip($zip)
            ->setStateProvince($stateProvince);
    }
    /**
     * Get coverageId value
     * @return int|null
     */
    public function getCoverageId()
    {
        return $this->coverageId;
    }
    /**
     * Set coverageId value
     * @param int $coverageId
     * @return \StructType\GetTermsDocId
     */
    public function setCoverageId($coverageId = null)
    {
        // validation for constraint: int
        if (!is_null($coverageId) && !(is_int($coverageId) || ctype_digit($coverageId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($coverageId, true), gettype($coverageId)), __LINE__);
        }
        $this->coverageId = $coverageId;
        return $this;
    }
    /**
     * Get zip value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getZip()
    {
        return isset($this->zip) ? $this->zip : null;
    }
    /**
     * Set zip value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $zip
     * @return \StructType\GetTermsDocId
     */
    public function setZip($zip = null)
    {
        // validation for constraint: string
        if (!is_null($zip) && !is_string($zip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zip, true), gettype($zip)), __LINE__);
        }
        if (is_null($zip) || (is_array($zip) && empty($zip))) {
            unset($this->zip);
        } else {
            $this->zip = $zip;
        }
        return $this;
    }
    /**
     * Get stateProvince value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStateProvince()
    {
        return isset($this->stateProvince) ? $this->stateProvince : null;
    }
    /**
     * Set stateProvince value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stateProvince
     * @return \StructType\GetTermsDocId
     */
    public function setStateProvince($stateProvince = null)
    {
        // validation for constraint: string
        if (!is_null($stateProvince) && !is_string($stateProvince)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateProvince, true), gettype($stateProvince)), __LINE__);
        }
        if (is_null($stateProvince) || (is_array($stateProvince) && empty($stateProvince))) {
            unset($this->stateProvince);
        } else {
            $this->stateProvince = $stateProvince;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetTermsDocId
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
