<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUsers StructType
 * @subpackage Structs
 */
class GetUsers extends AbstractStructBase
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Active;
    /**
     * The Terminated
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Terminated;
    /**
     * The Locked
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Locked;
    /**
     * The ShowInLists
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ShowInLists;
    /**
     * The HasRoles
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $HasRoles;
    /**
     * Constructor method for GetUsers
     * @uses GetUsers::setActive()
     * @uses GetUsers::setTerminated()
     * @uses GetUsers::setLocked()
     * @uses GetUsers::setShowInLists()
     * @uses GetUsers::setHasRoles()
     * @param bool $active
     * @param bool $terminated
     * @param bool $locked
     * @param bool $showInLists
     * @param bool $hasRoles
     */
    public function __construct($active = null, $terminated = null, $locked = null, $showInLists = null, $hasRoles = null)
    {
        $this
            ->setActive($active)
            ->setTerminated($terminated)
            ->setLocked($locked)
            ->setShowInLists($showInLists)
            ->setHasRoles($hasRoles);
    }
    /**
     * Get Active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->Active;
    }
    /**
     * Set Active value
     * @param bool $active
     * @return \StructType\GetUsers
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->Active = $active;
        return $this;
    }
    /**
     * Get Terminated value
     * @return bool|null
     */
    public function getTerminated()
    {
        return $this->Terminated;
    }
    /**
     * Set Terminated value
     * @param bool $terminated
     * @return \StructType\GetUsers
     */
    public function setTerminated($terminated = null)
    {
        // validation for constraint: boolean
        if (!is_null($terminated) && !is_bool($terminated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($terminated, true), gettype($terminated)), __LINE__);
        }
        $this->Terminated = $terminated;
        return $this;
    }
    /**
     * Get Locked value
     * @return bool|null
     */
    public function getLocked()
    {
        return $this->Locked;
    }
    /**
     * Set Locked value
     * @param bool $locked
     * @return \StructType\GetUsers
     */
    public function setLocked($locked = null)
    {
        // validation for constraint: boolean
        if (!is_null($locked) && !is_bool($locked)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($locked, true), gettype($locked)), __LINE__);
        }
        $this->Locked = $locked;
        return $this;
    }
    /**
     * Get ShowInLists value
     * @return bool|null
     */
    public function getShowInLists()
    {
        return $this->ShowInLists;
    }
    /**
     * Set ShowInLists value
     * @param bool $showInLists
     * @return \StructType\GetUsers
     */
    public function setShowInLists($showInLists = null)
    {
        // validation for constraint: boolean
        if (!is_null($showInLists) && !is_bool($showInLists)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showInLists, true), gettype($showInLists)), __LINE__);
        }
        $this->ShowInLists = $showInLists;
        return $this;
    }
    /**
     * Get HasRoles value
     * @return bool|null
     */
    public function getHasRoles()
    {
        return $this->HasRoles;
    }
    /**
     * Set HasRoles value
     * @param bool $hasRoles
     * @return \StructType\GetUsers
     */
    public function setHasRoles($hasRoles = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasRoles) && !is_bool($hasRoles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($hasRoles, true), gettype($hasRoles)), __LINE__);
        }
        $this->HasRoles = $hasRoles;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUsers
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
