<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVehicleModelsByMake StructType
 * @subpackage Structs
 */
class GetVehicleModelsByMake extends AbstractStructBase
{
    /**
     * The vehicleMake
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleMake
     */
    public $vehicleMake;
    /**
     * The yearFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $yearFilter;
    /**
     * Constructor method for GetVehicleModelsByMake
     * @uses GetVehicleModelsByMake::setVehicleMake()
     * @uses GetVehicleModelsByMake::setYearFilter()
     * @param \StructType\VehicleMake $vehicleMake
     * @param int $yearFilter
     */
    public function __construct(\StructType\VehicleMake $vehicleMake = null, $yearFilter = null)
    {
        $this
            ->setVehicleMake($vehicleMake)
            ->setYearFilter($yearFilter);
    }
    /**
     * Get vehicleMake value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleMake|null
     */
    public function getVehicleMake()
    {
        return isset($this->vehicleMake) ? $this->vehicleMake : null;
    }
    /**
     * Set vehicleMake value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\VehicleMake $vehicleMake
     * @return \StructType\GetVehicleModelsByMake
     */
    public function setVehicleMake(\StructType\VehicleMake $vehicleMake = null)
    {
        if (is_null($vehicleMake) || (is_array($vehicleMake) && empty($vehicleMake))) {
            unset($this->vehicleMake);
        } else {
            $this->vehicleMake = $vehicleMake;
        }
        return $this;
    }
    /**
     * Get yearFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getYearFilter()
    {
        return isset($this->yearFilter) ? $this->yearFilter : null;
    }
    /**
     * Set yearFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $yearFilter
     * @return \StructType\GetVehicleModelsByMake
     */
    public function setYearFilter($yearFilter = null)
    {
        // validation for constraint: int
        if (!is_null($yearFilter) && !(is_int($yearFilter) || ctype_digit($yearFilter))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($yearFilter, true), gettype($yearFilter)), __LINE__);
        }
        if (is_null($yearFilter) || (is_array($yearFilter) && empty($yearFilter))) {
            unset($this->yearFilter);
        } else {
            $this->yearFilter = $yearFilter;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVehicleModelsByMake
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
