<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVehicleTrimLevelsByModel StructType
 * @subpackage Structs
 */
class GetVehicleTrimLevelsByModel extends AbstractStructBase
{
    /**
     * The vehicleModel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleModel
     */
    public $vehicleModel;
    /**
     * The trimFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleTrim
     */
    public $trimFilter;
    /**
     * Constructor method for GetVehicleTrimLevelsByModel
     * @uses GetVehicleTrimLevelsByModel::setVehicleModel()
     * @uses GetVehicleTrimLevelsByModel::setTrimFilter()
     * @param \StructType\VehicleModel $vehicleModel
     * @param \StructType\VehicleTrim $trimFilter
     */
    public function __construct(\StructType\VehicleModel $vehicleModel = null, \StructType\VehicleTrim $trimFilter = null)
    {
        $this
            ->setVehicleModel($vehicleModel)
            ->setTrimFilter($trimFilter);
    }
    /**
     * Get vehicleModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleModel|null
     */
    public function getVehicleModel()
    {
        return isset($this->vehicleModel) ? $this->vehicleModel : null;
    }
    /**
     * Set vehicleModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\VehicleModel $vehicleModel
     * @return \StructType\GetVehicleTrimLevelsByModel
     */
    public function setVehicleModel(\StructType\VehicleModel $vehicleModel = null)
    {
        if (is_null($vehicleModel) || (is_array($vehicleModel) && empty($vehicleModel))) {
            unset($this->vehicleModel);
        } else {
            $this->vehicleModel = $vehicleModel;
        }
        return $this;
    }
    /**
     * Get trimFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleTrim|null
     */
    public function getTrimFilter()
    {
        return isset($this->trimFilter) ? $this->trimFilter : null;
    }
    /**
     * Set trimFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\VehicleTrim $trimFilter
     * @return \StructType\GetVehicleTrimLevelsByModel
     */
    public function setTrimFilter(\StructType\VehicleTrim $trimFilter = null)
    {
        if (is_null($trimFilter) || (is_array($trimFilter) && empty($trimFilter))) {
            unset($this->trimFilter);
        } else {
            $this->trimFilter = $trimFilter;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVehicleTrimLevelsByModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
