<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PhoneCall StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PhoneCall
 * @subpackage Structs
 */
class PhoneCall extends AbstractStructBase
{
    /**
     * The CallDuration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $CallDuration;
    /**
     * The CallEndTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CallEndTime;
    /**
     * The CallStartTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CallStartTime;
    /**
     * The CalledNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CalledNumber;
    /**
     * The CallerId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CallerId;
    /**
     * The CampaignId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $CampaignId;
    /**
     * The EntityId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $EntityId;
    /**
     * The EntityType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EntityType;
    /**
     * The ExternalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalId;
    /**
     * The HoldDuration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $HoldDuration;
    /**
     * The PhoneCallId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PhoneCallId;
    /**
     * The RecordingUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RecordingUrl;
    /**
     * The UserId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UserId;
    /**
     * Constructor method for PhoneCall
     * @uses PhoneCall::setCallDuration()
     * @uses PhoneCall::setCallEndTime()
     * @uses PhoneCall::setCallStartTime()
     * @uses PhoneCall::setCalledNumber()
     * @uses PhoneCall::setCallerId()
     * @uses PhoneCall::setCampaignId()
     * @uses PhoneCall::setEntityId()
     * @uses PhoneCall::setEntityType()
     * @uses PhoneCall::setExternalId()
     * @uses PhoneCall::setHoldDuration()
     * @uses PhoneCall::setPhoneCallId()
     * @uses PhoneCall::setRecordingUrl()
     * @uses PhoneCall::setUserId()
     * @param int $callDuration
     * @param string $callEndTime
     * @param string $callStartTime
     * @param string $calledNumber
     * @param string $callerId
     * @param int $campaignId
     * @param int $entityId
     * @param string $entityType
     * @param string $externalId
     * @param int $holdDuration
     * @param int $phoneCallId
     * @param string $recordingUrl
     * @param string $userId
     */
    public function __construct($callDuration = null, $callEndTime = null, $callStartTime = null, $calledNumber = null, $callerId = null, $campaignId = null, $entityId = null, $entityType = null, $externalId = null, $holdDuration = null, $phoneCallId = null, $recordingUrl = null, $userId = null)
    {
        $this
            ->setCallDuration($callDuration)
            ->setCallEndTime($callEndTime)
            ->setCallStartTime($callStartTime)
            ->setCalledNumber($calledNumber)
            ->setCallerId($callerId)
            ->setCampaignId($campaignId)
            ->setEntityId($entityId)
            ->setEntityType($entityType)
            ->setExternalId($externalId)
            ->setHoldDuration($holdDuration)
            ->setPhoneCallId($phoneCallId)
            ->setRecordingUrl($recordingUrl)
            ->setUserId($userId);
    }
    /**
     * Get CallDuration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCallDuration()
    {
        return isset($this->CallDuration) ? $this->CallDuration : null;
    }
    /**
     * Set CallDuration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $callDuration
     * @return \StructType\PhoneCall
     */
    public function setCallDuration($callDuration = null)
    {
        // validation for constraint: int
        if (!is_null($callDuration) && !(is_int($callDuration) || ctype_digit($callDuration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($callDuration, true), gettype($callDuration)), __LINE__);
        }
        if (is_null($callDuration) || (is_array($callDuration) && empty($callDuration))) {
            unset($this->CallDuration);
        } else {
            $this->CallDuration = $callDuration;
        }
        return $this;
    }
    /**
     * Get CallEndTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCallEndTime()
    {
        return isset($this->CallEndTime) ? $this->CallEndTime : null;
    }
    /**
     * Set CallEndTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $callEndTime
     * @return \StructType\PhoneCall
     */
    public function setCallEndTime($callEndTime = null)
    {
        // validation for constraint: string
        if (!is_null($callEndTime) && !is_string($callEndTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callEndTime, true), gettype($callEndTime)), __LINE__);
        }
        if (is_null($callEndTime) || (is_array($callEndTime) && empty($callEndTime))) {
            unset($this->CallEndTime);
        } else {
            $this->CallEndTime = $callEndTime;
        }
        return $this;
    }
    /**
     * Get CallStartTime value
     * @return string|null
     */
    public function getCallStartTime()
    {
        return $this->CallStartTime;
    }
    /**
     * Set CallStartTime value
     * @param string $callStartTime
     * @return \StructType\PhoneCall
     */
    public function setCallStartTime($callStartTime = null)
    {
        // validation for constraint: string
        if (!is_null($callStartTime) && !is_string($callStartTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callStartTime, true), gettype($callStartTime)), __LINE__);
        }
        $this->CallStartTime = $callStartTime;
        return $this;
    }
    /**
     * Get CalledNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCalledNumber()
    {
        return isset($this->CalledNumber) ? $this->CalledNumber : null;
    }
    /**
     * Set CalledNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $calledNumber
     * @return \StructType\PhoneCall
     */
    public function setCalledNumber($calledNumber = null)
    {
        // validation for constraint: string
        if (!is_null($calledNumber) && !is_string($calledNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($calledNumber, true), gettype($calledNumber)), __LINE__);
        }
        if (is_null($calledNumber) || (is_array($calledNumber) && empty($calledNumber))) {
            unset($this->CalledNumber);
        } else {
            $this->CalledNumber = $calledNumber;
        }
        return $this;
    }
    /**
     * Get CallerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCallerId()
    {
        return isset($this->CallerId) ? $this->CallerId : null;
    }
    /**
     * Set CallerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $callerId
     * @return \StructType\PhoneCall
     */
    public function setCallerId($callerId = null)
    {
        // validation for constraint: string
        if (!is_null($callerId) && !is_string($callerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callerId, true), gettype($callerId)), __LINE__);
        }
        if (is_null($callerId) || (is_array($callerId) && empty($callerId))) {
            unset($this->CallerId);
        } else {
            $this->CallerId = $callerId;
        }
        return $this;
    }
    /**
     * Get CampaignId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCampaignId()
    {
        return isset($this->CampaignId) ? $this->CampaignId : null;
    }
    /**
     * Set CampaignId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $campaignId
     * @return \StructType\PhoneCall
     */
    public function setCampaignId($campaignId = null)
    {
        // validation for constraint: int
        if (!is_null($campaignId) && !(is_int($campaignId) || ctype_digit($campaignId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($campaignId, true), gettype($campaignId)), __LINE__);
        }
        if (is_null($campaignId) || (is_array($campaignId) && empty($campaignId))) {
            unset($this->CampaignId);
        } else {
            $this->CampaignId = $campaignId;
        }
        return $this;
    }
    /**
     * Get EntityId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getEntityId()
    {
        return isset($this->EntityId) ? $this->EntityId : null;
    }
    /**
     * Set EntityId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $entityId
     * @return \StructType\PhoneCall
     */
    public function setEntityId($entityId = null)
    {
        // validation for constraint: int
        if (!is_null($entityId) && !(is_int($entityId) || ctype_digit($entityId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($entityId, true), gettype($entityId)), __LINE__);
        }
        if (is_null($entityId) || (is_array($entityId) && empty($entityId))) {
            unset($this->EntityId);
        } else {
            $this->EntityId = $entityId;
        }
        return $this;
    }
    /**
     * Get EntityType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEntityType()
    {
        return isset($this->EntityType) ? $this->EntityType : null;
    }
    /**
     * Set EntityType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $entityType
     * @return \StructType\PhoneCall
     */
    public function setEntityType($entityType = null)
    {
        // validation for constraint: string
        if (!is_null($entityType) && !is_string($entityType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($entityType, true), gettype($entityType)), __LINE__);
        }
        if (is_null($entityType) || (is_array($entityType) && empty($entityType))) {
            unset($this->EntityType);
        } else {
            $this->EntityType = $entityType;
        }
        return $this;
    }
    /**
     * Get ExternalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalId()
    {
        return isset($this->ExternalId) ? $this->ExternalId : null;
    }
    /**
     * Set ExternalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalId
     * @return \StructType\PhoneCall
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: string
        if (!is_null($externalId) && !is_string($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalId, true), gettype($externalId)), __LINE__);
        }
        if (is_null($externalId) || (is_array($externalId) && empty($externalId))) {
            unset($this->ExternalId);
        } else {
            $this->ExternalId = $externalId;
        }
        return $this;
    }
    /**
     * Get HoldDuration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getHoldDuration()
    {
        return isset($this->HoldDuration) ? $this->HoldDuration : null;
    }
    /**
     * Set HoldDuration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $holdDuration
     * @return \StructType\PhoneCall
     */
    public function setHoldDuration($holdDuration = null)
    {
        // validation for constraint: int
        if (!is_null($holdDuration) && !(is_int($holdDuration) || ctype_digit($holdDuration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($holdDuration, true), gettype($holdDuration)), __LINE__);
        }
        if (is_null($holdDuration) || (is_array($holdDuration) && empty($holdDuration))) {
            unset($this->HoldDuration);
        } else {
            $this->HoldDuration = $holdDuration;
        }
        return $this;
    }
    /**
     * Get PhoneCallId value
     * @return int|null
     */
    public function getPhoneCallId()
    {
        return $this->PhoneCallId;
    }
    /**
     * Set PhoneCallId value
     * @param int $phoneCallId
     * @return \StructType\PhoneCall
     */
    public function setPhoneCallId($phoneCallId = null)
    {
        // validation for constraint: int
        if (!is_null($phoneCallId) && !(is_int($phoneCallId) || ctype_digit($phoneCallId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($phoneCallId, true), gettype($phoneCallId)), __LINE__);
        }
        $this->PhoneCallId = $phoneCallId;
        return $this;
    }
    /**
     * Get RecordingUrl value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRecordingUrl()
    {
        return isset($this->RecordingUrl) ? $this->RecordingUrl : null;
    }
    /**
     * Set RecordingUrl value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $recordingUrl
     * @return \StructType\PhoneCall
     */
    public function setRecordingUrl($recordingUrl = null)
    {
        // validation for constraint: string
        if (!is_null($recordingUrl) && !is_string($recordingUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recordingUrl, true), gettype($recordingUrl)), __LINE__);
        }
        if (is_null($recordingUrl) || (is_array($recordingUrl) && empty($recordingUrl))) {
            unset($this->RecordingUrl);
        } else {
            $this->RecordingUrl = $recordingUrl;
        }
        return $this;
    }
    /**
     * Get UserId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserId()
    {
        return isset($this->UserId) ? $this->UserId : null;
    }
    /**
     * Set UserId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userId
     * @return \StructType\PhoneCall
     */
    public function setUserId($userId = null)
    {
        // validation for constraint: string
        if (!is_null($userId) && !is_string($userId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userId, true), gettype($userId)), __LINE__);
        }
        if (is_null($userId) || (is_array($userId) && empty($userId))) {
            unset($this->UserId);
        } else {
            $this->UserId = $userId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PhoneCall
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
