<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for secureWebService.DecodeVinReturn StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:secureWebService.DecodeVinReturn
 * @subpackage Structs
 */
class SecureWebService_DecodeVinReturn extends AbstractStructBase
{
    /**
     * The allVehicleTrims
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfVehicleTrim
     */
    public $allVehicleTrims;
    /**
     * The makeName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $makeName;
    /**
     * The modelName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $modelName;
    /**
     * The modelYear
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $modelYear;
    /**
     * The vehicleMakeId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $vehicleMakeId;
    /**
     * The vehicleModelId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $vehicleModelId;
    /**
     * Constructor method for secureWebService.DecodeVinReturn
     * @uses SecureWebService_DecodeVinReturn::setAllVehicleTrims()
     * @uses SecureWebService_DecodeVinReturn::setMakeName()
     * @uses SecureWebService_DecodeVinReturn::setModelName()
     * @uses SecureWebService_DecodeVinReturn::setModelYear()
     * @uses SecureWebService_DecodeVinReturn::setVehicleMakeId()
     * @uses SecureWebService_DecodeVinReturn::setVehicleModelId()
     * @param \ArrayType\ArrayOfVehicleTrim $allVehicleTrims
     * @param string $makeName
     * @param string $modelName
     * @param int $modelYear
     * @param int $vehicleMakeId
     * @param int $vehicleModelId
     */
    public function __construct(\ArrayType\ArrayOfVehicleTrim $allVehicleTrims = null, $makeName = null, $modelName = null, $modelYear = null, $vehicleMakeId = null, $vehicleModelId = null)
    {
        $this
            ->setAllVehicleTrims($allVehicleTrims)
            ->setMakeName($makeName)
            ->setModelName($modelName)
            ->setModelYear($modelYear)
            ->setVehicleMakeId($vehicleMakeId)
            ->setVehicleModelId($vehicleModelId);
    }
    /**
     * Get allVehicleTrims value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfVehicleTrim|null
     */
    public function getAllVehicleTrims()
    {
        return isset($this->allVehicleTrims) ? $this->allVehicleTrims : null;
    }
    /**
     * Set allVehicleTrims value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfVehicleTrim $allVehicleTrims
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public function setAllVehicleTrims(\ArrayType\ArrayOfVehicleTrim $allVehicleTrims = null)
    {
        if (is_null($allVehicleTrims) || (is_array($allVehicleTrims) && empty($allVehicleTrims))) {
            unset($this->allVehicleTrims);
        } else {
            $this->allVehicleTrims = $allVehicleTrims;
        }
        return $this;
    }
    /**
     * Get makeName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMakeName()
    {
        return isset($this->makeName) ? $this->makeName : null;
    }
    /**
     * Set makeName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $makeName
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public function setMakeName($makeName = null)
    {
        // validation for constraint: string
        if (!is_null($makeName) && !is_string($makeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($makeName, true), gettype($makeName)), __LINE__);
        }
        if (is_null($makeName) || (is_array($makeName) && empty($makeName))) {
            unset($this->makeName);
        } else {
            $this->makeName = $makeName;
        }
        return $this;
    }
    /**
     * Get modelName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getModelName()
    {
        return isset($this->modelName) ? $this->modelName : null;
    }
    /**
     * Set modelName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $modelName
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public function setModelName($modelName = null)
    {
        // validation for constraint: string
        if (!is_null($modelName) && !is_string($modelName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modelName, true), gettype($modelName)), __LINE__);
        }
        if (is_null($modelName) || (is_array($modelName) && empty($modelName))) {
            unset($this->modelName);
        } else {
            $this->modelName = $modelName;
        }
        return $this;
    }
    /**
     * Get modelYear value
     * @return int|null
     */
    public function getModelYear()
    {
        return $this->modelYear;
    }
    /**
     * Set modelYear value
     * @param int $modelYear
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public function setModelYear($modelYear = null)
    {
        // validation for constraint: int
        if (!is_null($modelYear) && !(is_int($modelYear) || ctype_digit($modelYear))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($modelYear, true), gettype($modelYear)), __LINE__);
        }
        $this->modelYear = $modelYear;
        return $this;
    }
    /**
     * Get vehicleMakeId value
     * @return int|null
     */
    public function getVehicleMakeId()
    {
        return $this->vehicleMakeId;
    }
    /**
     * Set vehicleMakeId value
     * @param int $vehicleMakeId
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public function setVehicleMakeId($vehicleMakeId = null)
    {
        // validation for constraint: int
        if (!is_null($vehicleMakeId) && !(is_int($vehicleMakeId) || ctype_digit($vehicleMakeId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($vehicleMakeId, true), gettype($vehicleMakeId)), __LINE__);
        }
        $this->vehicleMakeId = $vehicleMakeId;
        return $this;
    }
    /**
     * Get vehicleModelId value
     * @return int|null
     */
    public function getVehicleModelId()
    {
        return $this->vehicleModelId;
    }
    /**
     * Set vehicleModelId value
     * @param int $vehicleModelId
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public function setVehicleModelId($vehicleModelId = null)
    {
        // validation for constraint: int
        if (!is_null($vehicleModelId) && !(is_int($vehicleModelId) || ctype_digit($vehicleModelId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($vehicleModelId, true), gettype($vehicleModelId)), __LINE__);
        }
        $this->vehicleModelId = $vehicleModelId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SecureWebService_DecodeVinReturn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
