<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for secureWebService.GetRatesDecodedParams StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:secureWebService.GetRatesDecodedParams
 * @subpackage Structs
 */
class SecureWebService_GetRatesDecodedParams extends AbstractStructBase
{
    /**
     * The campaignId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $campaignId;
    /**
     * The coverageIdFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $coverageIdFilter;
    /**
     * The coverageLevelFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_RangeFilter
     */
    public $coverageLevelFilter;
    /**
     * The deductibleFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_RangeFilter
     */
    public $deductibleFilter;
    /**
     * The endOdometerFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_RangeFilter
     */
    public $endOdometerFilter;
    /**
     * The milesPerYearFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_RangeFilter
     */
    public $milesPerYearFilter;
    /**
     * The odometer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $odometer;
    /**
     * The productIdFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $productIdFilter;
    /**
     * The purchaseDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $purchaseDate;
    /**
     * The purchasePrice
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $purchasePrice;
    /**
     * The stateProvince
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $stateProvince;
    /**
     * The termMilesFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_RangeFilter
     */
    public $termMilesFilter;
    /**
     * The termMonthsFilter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SecureWebService_RangeFilter
     */
    public $termMonthsFilter;
    /**
     * The vin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $vin;
    /**
     * The zip
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $zip;
    /**
     * Constructor method for secureWebService.GetRatesDecodedParams
     * @uses SecureWebService_GetRatesDecodedParams::setCampaignId()
     * @uses SecureWebService_GetRatesDecodedParams::setCoverageIdFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setCoverageLevelFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setDeductibleFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setEndOdometerFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setMilesPerYearFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setOdometer()
     * @uses SecureWebService_GetRatesDecodedParams::setProductIdFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setPurchaseDate()
     * @uses SecureWebService_GetRatesDecodedParams::setPurchasePrice()
     * @uses SecureWebService_GetRatesDecodedParams::setStateProvince()
     * @uses SecureWebService_GetRatesDecodedParams::setTermMilesFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setTermMonthsFilter()
     * @uses SecureWebService_GetRatesDecodedParams::setVin()
     * @uses SecureWebService_GetRatesDecodedParams::setZip()
     * @param int $campaignId
     * @param \ArrayType\ArrayOfint $coverageIdFilter
     * @param \StructType\SecureWebService_RangeFilter $coverageLevelFilter
     * @param \StructType\SecureWebService_RangeFilter $deductibleFilter
     * @param \StructType\SecureWebService_RangeFilter $endOdometerFilter
     * @param \StructType\SecureWebService_RangeFilter $milesPerYearFilter
     * @param int $odometer
     * @param \ArrayType\ArrayOfint $productIdFilter
     * @param string $purchaseDate
     * @param float $purchasePrice
     * @param string $stateProvince
     * @param \StructType\SecureWebService_RangeFilter $termMilesFilter
     * @param \StructType\SecureWebService_RangeFilter $termMonthsFilter
     * @param string $vin
     * @param string $zip
     */
    public function __construct($campaignId = null, \ArrayType\ArrayOfint $coverageIdFilter = null, \StructType\SecureWebService_RangeFilter $coverageLevelFilter = null, \StructType\SecureWebService_RangeFilter $deductibleFilter = null, \StructType\SecureWebService_RangeFilter $endOdometerFilter = null, \StructType\SecureWebService_RangeFilter $milesPerYearFilter = null, $odometer = null, \ArrayType\ArrayOfint $productIdFilter = null, $purchaseDate = null, $purchasePrice = null, $stateProvince = null, \StructType\SecureWebService_RangeFilter $termMilesFilter = null, \StructType\SecureWebService_RangeFilter $termMonthsFilter = null, $vin = null, $zip = null)
    {
        $this
            ->setCampaignId($campaignId)
            ->setCoverageIdFilter($coverageIdFilter)
            ->setCoverageLevelFilter($coverageLevelFilter)
            ->setDeductibleFilter($deductibleFilter)
            ->setEndOdometerFilter($endOdometerFilter)
            ->setMilesPerYearFilter($milesPerYearFilter)
            ->setOdometer($odometer)
            ->setProductIdFilter($productIdFilter)
            ->setPurchaseDate($purchaseDate)
            ->setPurchasePrice($purchasePrice)
            ->setStateProvince($stateProvince)
            ->setTermMilesFilter($termMilesFilter)
            ->setTermMonthsFilter($termMonthsFilter)
            ->setVin($vin)
            ->setZip($zip);
    }
    /**
     * Get campaignId value
     * @return int|null
     */
    public function getCampaignId()
    {
        return $this->campaignId;
    }
    /**
     * Set campaignId value
     * @param int $campaignId
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setCampaignId($campaignId = null)
    {
        // validation for constraint: int
        if (!is_null($campaignId) && !(is_int($campaignId) || ctype_digit($campaignId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($campaignId, true), gettype($campaignId)), __LINE__);
        }
        $this->campaignId = $campaignId;
        return $this;
    }
    /**
     * Get coverageIdFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getCoverageIdFilter()
    {
        return isset($this->coverageIdFilter) ? $this->coverageIdFilter : null;
    }
    /**
     * Set coverageIdFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $coverageIdFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setCoverageIdFilter(\ArrayType\ArrayOfint $coverageIdFilter = null)
    {
        if (is_null($coverageIdFilter) || (is_array($coverageIdFilter) && empty($coverageIdFilter))) {
            unset($this->coverageIdFilter);
        } else {
            $this->coverageIdFilter = $coverageIdFilter;
        }
        return $this;
    }
    /**
     * Get coverageLevelFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_RangeFilter|null
     */
    public function getCoverageLevelFilter()
    {
        return isset($this->coverageLevelFilter) ? $this->coverageLevelFilter : null;
    }
    /**
     * Set coverageLevelFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SecureWebService_RangeFilter $coverageLevelFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setCoverageLevelFilter(\StructType\SecureWebService_RangeFilter $coverageLevelFilter = null)
    {
        if (is_null($coverageLevelFilter) || (is_array($coverageLevelFilter) && empty($coverageLevelFilter))) {
            unset($this->coverageLevelFilter);
        } else {
            $this->coverageLevelFilter = $coverageLevelFilter;
        }
        return $this;
    }
    /**
     * Get deductibleFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_RangeFilter|null
     */
    public function getDeductibleFilter()
    {
        return isset($this->deductibleFilter) ? $this->deductibleFilter : null;
    }
    /**
     * Set deductibleFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SecureWebService_RangeFilter $deductibleFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setDeductibleFilter(\StructType\SecureWebService_RangeFilter $deductibleFilter = null)
    {
        if (is_null($deductibleFilter) || (is_array($deductibleFilter) && empty($deductibleFilter))) {
            unset($this->deductibleFilter);
        } else {
            $this->deductibleFilter = $deductibleFilter;
        }
        return $this;
    }
    /**
     * Get endOdometerFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_RangeFilter|null
     */
    public function getEndOdometerFilter()
    {
        return isset($this->endOdometerFilter) ? $this->endOdometerFilter : null;
    }
    /**
     * Set endOdometerFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SecureWebService_RangeFilter $endOdometerFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setEndOdometerFilter(\StructType\SecureWebService_RangeFilter $endOdometerFilter = null)
    {
        if (is_null($endOdometerFilter) || (is_array($endOdometerFilter) && empty($endOdometerFilter))) {
            unset($this->endOdometerFilter);
        } else {
            $this->endOdometerFilter = $endOdometerFilter;
        }
        return $this;
    }
    /**
     * Get milesPerYearFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_RangeFilter|null
     */
    public function getMilesPerYearFilter()
    {
        return isset($this->milesPerYearFilter) ? $this->milesPerYearFilter : null;
    }
    /**
     * Set milesPerYearFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SecureWebService_RangeFilter $milesPerYearFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setMilesPerYearFilter(\StructType\SecureWebService_RangeFilter $milesPerYearFilter = null)
    {
        if (is_null($milesPerYearFilter) || (is_array($milesPerYearFilter) && empty($milesPerYearFilter))) {
            unset($this->milesPerYearFilter);
        } else {
            $this->milesPerYearFilter = $milesPerYearFilter;
        }
        return $this;
    }
    /**
     * Get odometer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getOdometer()
    {
        return isset($this->odometer) ? $this->odometer : null;
    }
    /**
     * Set odometer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $odometer
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setOdometer($odometer = null)
    {
        // validation for constraint: int
        if (!is_null($odometer) && !(is_int($odometer) || ctype_digit($odometer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($odometer, true), gettype($odometer)), __LINE__);
        }
        if (is_null($odometer) || (is_array($odometer) && empty($odometer))) {
            unset($this->odometer);
        } else {
            $this->odometer = $odometer;
        }
        return $this;
    }
    /**
     * Get productIdFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getProductIdFilter()
    {
        return isset($this->productIdFilter) ? $this->productIdFilter : null;
    }
    /**
     * Set productIdFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $productIdFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setProductIdFilter(\ArrayType\ArrayOfint $productIdFilter = null)
    {
        if (is_null($productIdFilter) || (is_array($productIdFilter) && empty($productIdFilter))) {
            unset($this->productIdFilter);
        } else {
            $this->productIdFilter = $productIdFilter;
        }
        return $this;
    }
    /**
     * Get purchaseDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPurchaseDate()
    {
        return isset($this->purchaseDate) ? $this->purchaseDate : null;
    }
    /**
     * Set purchaseDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $purchaseDate
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setPurchaseDate($purchaseDate = null)
    {
        // validation for constraint: string
        if (!is_null($purchaseDate) && !is_string($purchaseDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($purchaseDate, true), gettype($purchaseDate)), __LINE__);
        }
        if (is_null($purchaseDate) || (is_array($purchaseDate) && empty($purchaseDate))) {
            unset($this->purchaseDate);
        } else {
            $this->purchaseDate = $purchaseDate;
        }
        return $this;
    }
    /**
     * Get purchasePrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getPurchasePrice()
    {
        return isset($this->purchasePrice) ? $this->purchasePrice : null;
    }
    /**
     * Set purchasePrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $purchasePrice
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setPurchasePrice($purchasePrice = null)
    {
        // validation for constraint: float
        if (!is_null($purchasePrice) && !(is_float($purchasePrice) || is_numeric($purchasePrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($purchasePrice, true), gettype($purchasePrice)), __LINE__);
        }
        if (is_null($purchasePrice) || (is_array($purchasePrice) && empty($purchasePrice))) {
            unset($this->purchasePrice);
        } else {
            $this->purchasePrice = $purchasePrice;
        }
        return $this;
    }
    /**
     * Get stateProvince value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStateProvince()
    {
        return isset($this->stateProvince) ? $this->stateProvince : null;
    }
    /**
     * Set stateProvince value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stateProvince
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setStateProvince($stateProvince = null)
    {
        // validation for constraint: string
        if (!is_null($stateProvince) && !is_string($stateProvince)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateProvince, true), gettype($stateProvince)), __LINE__);
        }
        if (is_null($stateProvince) || (is_array($stateProvince) && empty($stateProvince))) {
            unset($this->stateProvince);
        } else {
            $this->stateProvince = $stateProvince;
        }
        return $this;
    }
    /**
     * Get termMilesFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_RangeFilter|null
     */
    public function getTermMilesFilter()
    {
        return isset($this->termMilesFilter) ? $this->termMilesFilter : null;
    }
    /**
     * Set termMilesFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SecureWebService_RangeFilter $termMilesFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setTermMilesFilter(\StructType\SecureWebService_RangeFilter $termMilesFilter = null)
    {
        if (is_null($termMilesFilter) || (is_array($termMilesFilter) && empty($termMilesFilter))) {
            unset($this->termMilesFilter);
        } else {
            $this->termMilesFilter = $termMilesFilter;
        }
        return $this;
    }
    /**
     * Get termMonthsFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SecureWebService_RangeFilter|null
     */
    public function getTermMonthsFilter()
    {
        return isset($this->termMonthsFilter) ? $this->termMonthsFilter : null;
    }
    /**
     * Set termMonthsFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\SecureWebService_RangeFilter $termMonthsFilter
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setTermMonthsFilter(\StructType\SecureWebService_RangeFilter $termMonthsFilter = null)
    {
        if (is_null($termMonthsFilter) || (is_array($termMonthsFilter) && empty($termMonthsFilter))) {
            unset($this->termMonthsFilter);
        } else {
            $this->termMonthsFilter = $termMonthsFilter;
        }
        return $this;
    }
    /**
     * Get vin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVin()
    {
        return isset($this->vin) ? $this->vin : null;
    }
    /**
     * Set vin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vin
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setVin($vin = null)
    {
        // validation for constraint: string
        if (!is_null($vin) && !is_string($vin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vin, true), gettype($vin)), __LINE__);
        }
        if (is_null($vin) || (is_array($vin) && empty($vin))) {
            unset($this->vin);
        } else {
            $this->vin = $vin;
        }
        return $this;
    }
    /**
     * Get zip value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getZip()
    {
        return isset($this->zip) ? $this->zip : null;
    }
    /**
     * Set zip value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $zip
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public function setZip($zip = null)
    {
        // validation for constraint: string
        if (!is_null($zip) && !is_string($zip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zip, true), gettype($zip)), __LINE__);
        }
        if (is_null($zip) || (is_array($zip) && empty($zip))) {
            unset($this->zip);
        } else {
            $this->zip = $zip;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SecureWebService_GetRatesDecodedParams
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
