<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for secureWebService.QueryReportParameter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:secureWebService.QueryReportParameter
 * @subpackage Structs
 */
class SecureWebService_QueryReportParameter extends AbstractStructBase
{
    /**
     * The ParamName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ParamName;
    /**
     * The ParamValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ParamValue;
    /**
     * Constructor method for secureWebService.QueryReportParameter
     * @uses SecureWebService_QueryReportParameter::setParamName()
     * @uses SecureWebService_QueryReportParameter::setParamValue()
     * @param string $paramName
     * @param string $paramValue
     */
    public function __construct($paramName = null, $paramValue = null)
    {
        $this
            ->setParamName($paramName)
            ->setParamValue($paramValue);
    }
    /**
     * Get ParamName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getParamName()
    {
        return isset($this->ParamName) ? $this->ParamName : null;
    }
    /**
     * Set ParamName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $paramName
     * @return \StructType\SecureWebService_QueryReportParameter
     */
    public function setParamName($paramName = null)
    {
        // validation for constraint: string
        if (!is_null($paramName) && !is_string($paramName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramName, true), gettype($paramName)), __LINE__);
        }
        if (is_null($paramName) || (is_array($paramName) && empty($paramName))) {
            unset($this->ParamName);
        } else {
            $this->ParamName = $paramName;
        }
        return $this;
    }
    /**
     * Get ParamValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getParamValue()
    {
        return isset($this->ParamValue) ? $this->ParamValue : null;
    }
    /**
     * Set ParamValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $paramValue
     * @return \StructType\SecureWebService_QueryReportParameter
     */
    public function setParamValue($paramValue = null)
    {
        // validation for constraint: string
        if (!is_null($paramValue) && !is_string($paramValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paramValue, true), gettype($paramValue)), __LINE__);
        }
        if (is_null($paramValue) || (is_array($paramValue) && empty($paramValue))) {
            unset($this->ParamValue);
        } else {
            $this->ParamValue = $paramValue;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SecureWebService_QueryReportParameter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
