<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for secureWebService.RangeFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:secureWebService.RangeFilter
 * @subpackage Structs
 */
class SecureWebService_RangeFilter extends AbstractStructBase
{
    /**
     * The maxValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $maxValue;
    /**
     * The minValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $minValue;
    /**
     * Constructor method for secureWebService.RangeFilter
     * @uses SecureWebService_RangeFilter::setMaxValue()
     * @uses SecureWebService_RangeFilter::setMinValue()
     * @param int $maxValue
     * @param int $minValue
     */
    public function __construct($maxValue = null, $minValue = null)
    {
        $this
            ->setMaxValue($maxValue)
            ->setMinValue($minValue);
    }
    /**
     * Get maxValue value
     * @return int|null
     */
    public function getMaxValue()
    {
        return $this->maxValue;
    }
    /**
     * Set maxValue value
     * @param int $maxValue
     * @return \StructType\SecureWebService_RangeFilter
     */
    public function setMaxValue($maxValue = null)
    {
        // validation for constraint: int
        if (!is_null($maxValue) && !(is_int($maxValue) || ctype_digit($maxValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxValue, true), gettype($maxValue)), __LINE__);
        }
        $this->maxValue = $maxValue;
        return $this;
    }
    /**
     * Get minValue value
     * @return int|null
     */
    public function getMinValue()
    {
        return $this->minValue;
    }
    /**
     * Set minValue value
     * @param int $minValue
     * @return \StructType\SecureWebService_RangeFilter
     */
    public function setMinValue($minValue = null)
    {
        // validation for constraint: int
        if (!is_null($minValue) && !(is_int($minValue) || ctype_digit($minValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($minValue, true), gettype($minValue)), __LINE__);
        }
        $this->minValue = $minValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SecureWebService_RangeFilter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
